package de.desy.web2cToolkit.web2c.web2cChatUtilities;

import java.util.ArrayList;
import java.util.Calendar;
import de.desy.web2cToolkit.web2cUtil.web2cInterfaces.IWeb2cConstants;


/**
 * @author R.Bacher, DESY
 */
public class Web2cChatChannel implements IWeb2cConstants {
	
	private ArrayList<String> chatConversation = null;
	private ArrayList<String> chatOut = null;

	 /**
     * Constructor
     * Chat channel 
     */
	public Web2cChatChannel() {
		
		chatConversation = new ArrayList<String>();
		chatOut = new ArrayList<String>();
	}
	
	 /**
     * Returns recorded conversation
     * @return chat conversation 
     */
	public ArrayList<String> getChat() {
	
		return chatOut;
	}
	
	 /**
     * Appends a chat contribution to the recorded chat conversation
     * @param name chat contributer's name
     * @param entry chat entry to append
     * @param prompt prompt type
     */
	public void appendChat(String name, String entry, String prompt) {
		
		Calendar calendar = Calendar.getInstance();
		
		if (chatConversation.toArray().length >= maxChatDepth) {
			chatConversation.remove(0);
		}
		
		if (prompt.equals("message")) {
			String item = calendar.getTime().toString() + " " + name + ": " + entry;
			chatConversation.add(item);
			chatOut.clear();
			for (int i = chatConversation.toArray().length - 1; i >= 0 ; i--) {
				chatOut.add((String)(chatConversation.toArray()[i]));
			}
		}
		else {
			String item = name + ": " + entry;
			chatConversation.add(item);
			chatOut.clear();
			for (int i = 0; i < chatConversation.toArray().length ; i++) {
				chatOut.add((String)(chatConversation.toArray()[i]));
			}
		}
	}
	
	 /**
     * Clears the chat conversation list
     */
	public void clearChat() {
		
		chatConversation.clear();
		chatOut.clear();
	}
}
