package de.desy.web2cToolkit.web2cLogbook.web2cGWT.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.AbsolutePanel;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.TabPanel;
import com.google.gwt.user.client.rpc.AsyncCallback;
import de.desy.web2cToolkit.web2cLogbook.web2cGWT.client.IWeb2cLogbookViewerRemoteService.Util;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.RichTextArea;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.user.client.ui.TextArea;

/**
 * Logbook Viewer GWT Page (will be cross-compiled to HTML-Tags, CSS-Tags and JavaScript code by GWT Compiler)
 * @author R.Bacher, DESY
 */
public class Web2cLogbookViewerPage implements EntryPoint {
	
	private RootPanel logbookViewerPageRootPanel;
	private AbsolutePanel logbookViewerPagePanel;
	private TabPanel logbookPageTabPanel;
	private Label logbookTitleLabel;
	
	private AbsolutePanel logbookPanel;
	private ListBox logbookNavigatorListBox;
	private RichTextArea logbookRecordTextRichTextArea;
	private Button logbookNewRecordButton;
	private Button logbookEditRecordButton;
	private Button logbookDeleteRecordButton;
	private Button logbookRefreshRecordButton;
	private Button logbookFirstRecordButton;
	private Button logbookPreviousRecordButton;
	private Button logbookNextRecordButton;
	private Button logbookMostRecentRecordButton;
	private Label logbookRecordAuthorLabel;
	private Label logbookRecordAuthorTextLabel;
	private Label logbookRecordTitleLabel;
	private TextBox logbookRecordTitleTextBox;
	private ListBox logbookImportanceListBox;
	private ListBox logbookCategoryListBox;
	private Label logbookRecordCategoryLabel;
	private Label logbookRecordImportanceLabel;
	private Label logbookRecordCreatedLabel;
	private Label logbookRecordCreatedTextLabel;
	private Label logbookRecordLastModifiedLabel;
	private Label logbookRecordLastModifiedTextLabel;
	private Button logbookSendToButton;
	private ListBox logbookRecipientListBox;
	
	private AbsolutePanel reportPanel;
	private ListBox reportReportListBox;
	private Label reportAvailableReportsLabel;
	private Button reportWriteReportButton;
	private Label reportReportTextLabel;
	private TextArea reportReportTextTextArea;
	
	private IWeb2cLogbookViewerRemoteServiceAsync logbookViewerRemoteService;
	
	private String recordIndex = "-1";
	private Button logbookClearRecordButton;
	
	/**
	 * Defines and initializes the logbook viewer GWT Page
	 */
	public void onModuleLoad() {	

		logbookViewerPageRootPanel = RootPanel.get();
		logbookViewerPageRootPanel.setSize("1245", "923");

		logbookViewerPagePanel = new AbsolutePanel();
		logbookViewerPageRootPanel.add(logbookViewerPagePanel, 10, 55);
		logbookViewerPagePanel.setSize("1184px", "789px");
		
			logbookPageTabPanel = new TabPanel();
			logbookViewerPagePanel.add(logbookPageTabPanel, 10, 10);
			logbookPageTabPanel.setSize("1150px", "745px");
			
			logbookTitleLabel = new Label("Logbook: ");
			logbookTitleLabel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_CENTER);
			logbookTitleLabel.setStyleName("gwt-LogbookPageHeader");
			logbookViewerPageRootPanel.add(logbookTitleLabel, 347, 10);
			logbookTitleLabel.setSize("555px", "29px");			
			logbookTitleLabel.setText("Logbook: " + getLogbookName());
					
				// logbookPanel
				logbookPanel = new AbsolutePanel();
				logbookPageTabPanel.add(logbookPanel, "Viewer", false);
				logbookPanel.setSize("1115px", "718px");
					
					logbookNavigatorListBox = new ListBox();
					logbookPanel.add(logbookNavigatorListBox, 10, 195);
					logbookNavigatorListBox.setSize("200px", "502px");
					logbookNavigatorListBox.setVisibleItemCount(5);
					
					logbookRecordTextRichTextArea = new RichTextArea();
					logbookPanel.add(logbookRecordTextRichTextArea, 228, 194);
					logbookRecordTextRichTextArea.setSize("865px", "490px");
					logbookRecordTextRichTextArea.setText("Enter text here ...");
					
					logbookNewRecordButton = new Button("");
					logbookNewRecordButton.setText("New ");
					logbookPanel.add(logbookNewRecordButton, 821, 10);
					logbookNewRecordButton.setSize("80px", "39px");
					
					logbookEditRecordButton = new Button("");
					logbookEditRecordButton.setText("Edit");
					logbookPanel.add(logbookEditRecordButton, 917, 10);
					logbookEditRecordButton.setSize("80px", "39px");
					
					logbookDeleteRecordButton = new Button("");
					logbookDeleteRecordButton.setText("Delete");
					logbookPanel.add(logbookDeleteRecordButton, 1015, 10);
					logbookDeleteRecordButton.setSize("80px", "39px");
					
					logbookRefreshRecordButton = new Button("");
					logbookRefreshRecordButton.setText("Refresh");
					logbookPanel.add(logbookRefreshRecordButton, 352, 10);
					logbookRefreshRecordButton.setSize("80px", "39px");
					
					logbookFirstRecordButton = new Button("");
					logbookFirstRecordButton.setText("|<");
					logbookPanel.add(logbookFirstRecordButton, 228, 10);
					logbookFirstRecordButton.setSize("44px", "39px");
					
					logbookPreviousRecordButton = new Button("");
					logbookPreviousRecordButton.setText("<");
					logbookPanel.add(logbookPreviousRecordButton, 290, 10);
					logbookPreviousRecordButton.setSize("44px", "39px");
					
					logbookNextRecordButton = new Button("");
					logbookNextRecordButton.setText(">");
					logbookPanel.add(logbookNextRecordButton, 545, 10);
					logbookNextRecordButton.setSize("44px", "39px");
					
					logbookMostRecentRecordButton = new Button("");
					logbookMostRecentRecordButton.setText(">|");
					logbookPanel.add(logbookMostRecentRecordButton, 604, 10);
					logbookMostRecentRecordButton.setSize("44px", "39px");
					
					logbookRecordAuthorLabel = new Label("Author: ");
					logbookPanel.add(logbookRecordAuthorLabel, 228, 113);
					logbookRecordAuthorLabel.setSize("78px", "28px");
					
					logbookRecordAuthorTextLabel = new Label();
					logbookPanel.add(logbookRecordAuthorTextLabel, 312, 111);
					logbookRecordAuthorTextLabel.setSize("336px", "30px");
					
					logbookRecordTitleLabel = new Label("Title:");
					logbookPanel.add(logbookRecordTitleLabel, 228, 65);
					logbookRecordTitleLabel.setSize("78px", "28px");
					
					logbookRecordTitleTextBox = new TextBox();
					logbookPanel.add(logbookRecordTitleTextBox, 312, 55);
					logbookRecordTitleTextBox.setSize("326px", "26px");
					
					logbookImportanceListBox = new ListBox();
					logbookPanel.add(logbookImportanceListBox, 983, 69);
					logbookImportanceListBox.setSize("107px", "60px");
					logbookImportanceListBox.setVisibleItemCount(3);
					
					logbookCategoryListBox = new ListBox();
					logbookCategoryListBox.setVisibleItemCount(3);
					logbookPanel.add(logbookCategoryListBox, 752, 69);
					logbookCategoryListBox.setSize("107px", "60px");
					
					logbookRecordCategoryLabel = new Label("Category:");
					logbookRecordCategoryLabel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_LEFT);
					logbookPanel.add(logbookRecordCategoryLabel, 666, 88);
					logbookRecordCategoryLabel.setSize("80px", "28px");
					
					logbookRecordImportanceLabel = new Label("Importance: ");
					logbookPanel.add(logbookRecordImportanceLabel, 891, 88);
					logbookRecordImportanceLabel.setSize("86px", "28px");
					
					logbookRecordCreatedLabel = new Label("Created:  ");
					logbookPanel.add(logbookRecordCreatedLabel, 228, 149);
					logbookRecordCreatedLabel.setSize("78px", "28px");
					
					logbookRecordCreatedTextLabel = new Label();
					logbookPanel.add(logbookRecordCreatedTextLabel, 312, 149);
					logbookRecordCreatedTextLabel.setSize("336px", "27px");
					
					logbookRecordLastModifiedLabel = new Label("Modified: ");
					logbookPanel.add(logbookRecordLastModifiedLabel, 666, 149);
					logbookRecordLastModifiedLabel.setSize("70px", "28px");
					
					logbookRecordLastModifiedTextLabel = new Label();
					logbookPanel.add(logbookRecordLastModifiedTextLabel, 765, 149);
					logbookRecordLastModifiedTextLabel.setSize("322px", "27px");
					
					logbookSendToButton = new Button("");
					logbookSendToButton.setText("Send E-Mail");
					logbookPanel.add(logbookSendToButton, 37, 133);
					logbookSendToButton.setSize("141px", "44px");
					
					logbookRecipientListBox = new ListBox();
					logbookPanel.add(logbookRecipientListBox, 10, 10);
					logbookRecipientListBox.setSize("200px", "117px");
					logbookRecipientListBox.setVisibleItemCount(5);
					
					logbookClearRecordButton = new Button("");
					logbookClearRecordButton.setText("Clear");
					logbookPanel.add(logbookClearRecordButton, 448, 10);
					logbookClearRecordButton.setSize("80px", "39px");				
					
				// reportPanel
				reportPanel = new AbsolutePanel();
				logbookPageTabPanel.add(reportPanel, "Reporter", false);
				reportPanel.setSize("1110px", "614px");
				
					reportReportListBox = new ListBox();
					reportPanel.add(reportReportListBox, 194, 67);
					reportReportListBox.setSize("435px", "167px");
					reportReportListBox.setVisibleItemCount(5);
				
					reportAvailableReportsLabel = new Label("Available Reports:");
					reportPanel.add(reportAvailableReportsLabel, 20, 130);
					reportAvailableReportsLabel.setSize("160px", "44px");
				
					reportWriteReportButton = new Button("Write Report");
					reportPanel.add(reportWriteReportButton, 777, 118);
					reportWriteReportButton.setSize("169px", "35px");
					
					reportReportTextLabel = new Label("Report Text:");
					reportPanel.add(reportReportTextLabel, 24, 424);
					reportReportTextLabel.setSize("131px", "28px");
				
					reportReportTextTextArea = new TextArea();
					reportReportTextTextArea.setReadOnly(true);
					reportReportTextTextArea.setVisibleLines(10);
					reportPanel.add(reportReportTextTextArea, 194, 295);
					reportReportTextTextArea.setSize("843px", "278px");
					
					
		logbookViewerRemoteService = Util.getInstance();
		
		logbookViewerRemoteService.getRecipients(getSessionId(), new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}

			public void onSuccess(String result) {
				if (result.contains("<recipient>")) {
					logbookRecipientListBox.clear();
					result = result.replace("<return><recipient>","").replace("</recipient></return>","");
					String[] recipients = result.split("</recipient><recipient>");
					for (int i = 0; i < recipients.length; i++) logbookRecipientListBox.addItem(recipients[i]);
					logbookRecipientListBox.setSelectedIndex(0);
				}
			}
		});

		logbookViewerRemoteService.getCategoryKeywords(getSessionId(), new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}

			public void onSuccess(String result) {
				if (result.contains("<category>")) {
					logbookCategoryListBox.clear();
					result = result.replace("<return><category>","").replace("</category></return>","");
					String[] keywords = result.split("</category><category>");
					for (int i = 0; i < keywords.length; i++) logbookCategoryListBox.addItem(keywords[i]);
					logbookCategoryListBox.setSelectedIndex(0);
				}
			}
		});

		logbookViewerRemoteService.getImportanceLevels(getSessionId(), new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}

			public void onSuccess(String result) {
				if (result.contains("<importance>")) {
					logbookImportanceListBox.clear();
					result = result.replace("<return><importance>","").replace("</importance></return>","");
					String[] levels = result.split("</importance><importance>");
					for (int i = 0; i < levels.length; i++) logbookImportanceListBox.addItem(levels[i]);
					logbookImportanceListBox.setSelectedIndex(0);
				}
			}
		});

		logbookViewerRemoteService.getLogbookTree(getSessionId(), new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}

			public void onSuccess(String result) {
				if (result.contains("<file>")) {
					logbookNavigatorListBox.clear();
					result = result.replace("<return><file>","").replace("</file></return>","");
					String[] fileNames = result.split("</file><file>");
					for (int i = 0; i < fileNames.length; i++) logbookNavigatorListBox.addItem(fileNames[i]);
					logbookNavigatorListBox.setSelectedIndex(0);
				}

				logbookViewerRemoteService.getMostRecentRecord(getSessionId(), logbookNavigatorListBox.getItemText(logbookNavigatorListBox.getSelectedIndex()), recordIndex, new AsyncCallback<String>() {
					public void onFailure(Throwable caught) {
					}

					public void onSuccess(String result) {
						decodeRecordString(result);
						changeAppendRecordMode();
					}
				});
			}
		});

		logbookNewRecordButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				if (logbookNavigatorListBox.getSelectedIndex() != -1) {
					logbookViewerRemoteService.appendRecord(getSessionId(), logbookNavigatorListBox.getItemText(logbookNavigatorListBox.getSelectedIndex()), encodeRecordString(), new AsyncCallback<String>() {
						public void onFailure(Throwable caught) {
						}

						public void onSuccess(String result) {
							recordIndex = result.replace("<return>", "").replace("</return>", "");
							logbookViewerRemoteService.getRecord(getSessionId(), logbookNavigatorListBox.getItemText(logbookNavigatorListBox.getSelectedIndex()), recordIndex, new AsyncCallback<String>() {
								public void onFailure(Throwable caught) {
								}

								public void onSuccess(String result) {
									decodeRecordString(result);
									changeAppendRecordMode();
								}
							});
						}
					});
				}
				else {
					Window.alert("Please select a logbook file!");
				}
			}
		});
		
		logbookEditRecordButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				if (logbookNavigatorListBox.getSelectedIndex() != -1) {
					logbookViewerRemoteService.editRecord(getSessionId(), logbookNavigatorListBox.getItemText(logbookNavigatorListBox.getSelectedIndex()), recordIndex, encodeRecordString(), new AsyncCallback<String>() {
						public void onFailure(Throwable caught) {
						}

						public void onSuccess(String result) {
							recordIndex = result.replace("<return>", "").replace("</return>", "");
							logbookViewerRemoteService.getRecord(getSessionId(), logbookNavigatorListBox.getItemText(logbookNavigatorListBox.getSelectedIndex()), recordIndex, new AsyncCallback<String>() {
								public void onFailure(Throwable caught) {
								}

								public void onSuccess(String result) {
									decodeRecordString(result);
									changeAppendRecordMode();
								}
							});
						}
					});
				}
				else {
					Window.alert("Please select a logbook file!");
				}
			}
		});

		logbookDeleteRecordButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				if (logbookNavigatorListBox.getSelectedIndex() != -1) {
					logbookViewerRemoteService.deleteRecord(getSessionId(), logbookNavigatorListBox.getItemText(logbookNavigatorListBox.getSelectedIndex()), recordIndex, encodeRecordString(), new AsyncCallback<String>() {
						public void onFailure(Throwable caught) {
						}

						public void onSuccess(String result) {
							recordIndex = result.replace("<return>", "").replace("</return>", "");
							logbookViewerRemoteService.getFirstRecord(getSessionId(), logbookNavigatorListBox.getItemText(logbookNavigatorListBox.getSelectedIndex()), recordIndex, new AsyncCallback<String>() {
								public void onFailure(Throwable caught) {
								}

								public void onSuccess(String result) {
									decodeRecordString(result);
									changeAppendRecordMode();
								}
							});
						}
					});
				}
				else {
					Window.alert("Please select a logbook file!");
				}
			}
		});

		logbookRefreshRecordButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				if (logbookNavigatorListBox.getSelectedIndex() != -1) {
					logbookViewerRemoteService.getRecord(getSessionId(), logbookNavigatorListBox.getItemText(logbookNavigatorListBox.getSelectedIndex()), recordIndex, new AsyncCallback<String>() {
						public void onFailure(Throwable caught) {
						}

						public void onSuccess(String result) {
							decodeRecordString(result);
							changeAppendRecordMode();
						}
					});
				}
				else {
					Window.alert("Please select a logbook file!");
				}
			}
		});

		logbookFirstRecordButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				if (logbookNavigatorListBox.getSelectedIndex() != -1) {
					logbookViewerRemoteService.getFirstRecord(getSessionId(), logbookNavigatorListBox.getItemText(logbookNavigatorListBox.getSelectedIndex()), recordIndex, new AsyncCallback<String>() {
						public void onFailure(Throwable caught) {
						}

						public void onSuccess(String result) {
							decodeRecordString(result);
							changeAppendRecordMode();
						}
					});
				}
				else {
					Window.alert("Please select a logbook file!");
				}
			}
		});

		logbookPreviousRecordButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				if (logbookNavigatorListBox.getSelectedIndex() != -1) {
					logbookViewerRemoteService.getPreviousRecord(getSessionId(), logbookNavigatorListBox.getItemText(logbookNavigatorListBox.getSelectedIndex()), recordIndex, new AsyncCallback<String>() {
						public void onFailure(Throwable caught) {
						}

						public void onSuccess(String result) {
							decodeRecordString(result);
							changeAppendRecordMode();
						}
					});
				}
				else {
					Window.alert("Please select a logbook file!");
				}
			}
		});

		logbookNextRecordButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				if (logbookNavigatorListBox.getSelectedIndex() != -1) {
					logbookViewerRemoteService.getNextRecord(getSessionId(), logbookNavigatorListBox.getItemText(logbookNavigatorListBox.getSelectedIndex()), recordIndex, new AsyncCallback<String>() {
						public void onFailure(Throwable caught) {
						}

						public void onSuccess(String result) {
							decodeRecordString(result);
							changeAppendRecordMode();
						}
					});
				}
				else {
					Window.alert("Please select a logbook file!");
				}
			}
		});

		logbookMostRecentRecordButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				if (logbookNavigatorListBox.getSelectedIndex() != -1) {
					logbookViewerRemoteService.getMostRecentRecord(getSessionId(), logbookNavigatorListBox.getItemText(logbookNavigatorListBox.getSelectedIndex()), recordIndex, new AsyncCallback<String>() {
						public void onFailure(Throwable caught) {
						}

						public void onSuccess(String result) {
							decodeRecordString(result);
							changeAppendRecordMode();
						}
					});
				}
				else {
					Window.alert("Please select a logbook file!");
				}
			}
		});

		logbookSendToButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				if (logbookRecipientListBox.getSelectedIndex() != -1) {
					if (logbookNavigatorListBox.getSelectedIndex() != -1) {
						logbookViewerRemoteService.sendNotification(getSessionId(), logbookNavigatorListBox.getItemText(logbookNavigatorListBox.getSelectedIndex()), recordIndex, logbookRecipientListBox.getItemText(logbookRecipientListBox.getSelectedIndex()), new AsyncCallback<Void>() {
							public void onFailure(Throwable caught) {
							}

							public void onSuccess(Void result) {
							}
						});
					}
					else {
						Window.alert("Please select a logbook file!");
					}
				}
				else {
					Window.alert("Please select a recipient!");
				}
			}
		});

		logbookClearRecordButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				clearRecordInputMask();
			}
		});
		
		logbookNavigatorListBox.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				logbookViewerRemoteService.getMostRecentRecord(getSessionId(), logbookNavigatorListBox.getItemText(logbookNavigatorListBox.getSelectedIndex()), recordIndex, new AsyncCallback<String>() {
					public void onFailure(Throwable caught) {
					}

					public void onSuccess(String result) {
						decodeRecordString(result);
						changeAppendRecordMode();
					}
				});
			}
		});

		logbookViewerRemoteService.getReportList(getSessionId(), new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}

			public void onSuccess(String result) {
				reportReportListBox.clear();
				if (result.contains("<report>")) {
					result = result.replace("<return><report>", "").replace("</report></return>", "");
					if (result.contains("</report><report>")) {
						String[] reportNames = result.split("</report><report>");
						for (int i = 0; i < reportNames.length; i++) reportReportListBox.addItem(reportNames[i]);
					}
					else {
						reportReportListBox.addItem(result);
					}
					reportReportListBox.setSelectedIndex(0);
				}
			}
		});
		
		reportWriteReportButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				if (reportReportListBox.getItemCount() != 0) {
					logbookViewerRemoteService.writeReport(getSessionId(), reportReportListBox.getItemText(reportReportListBox.getSelectedIndex()), new AsyncCallback<String>() {
						public void onFailure(Throwable caught) {
						}
	
						public void onSuccess(String result) {
							reportReportTextTextArea.setText("");
							String report = "";
							report = report + "Title:      " + parseString(result, "caption") + "\n";
							report = report + "Category:   " + parseString(result, "category") + "\n";
							report = report + "Importance: " + parseString(result, "importance") + "\n";
							report = report + "Text:       " + parseString(result, "text");
							reportReportTextTextArea.setText(report);
						}
					});
				}
			}
		});
	}
	
	/**
	 * Encodes all record-specific HTML field values (caption, author etc.) into a string (XML)
	 * @return record as string (XML)
	 */
	private String encodeRecordString() {

		String index = "<index>" + recordIndex + "</index>";
		String created = "<created>" + logbookRecordCreatedTextLabel.getText() + "</created>";
		String modified = "<modified>" + logbookRecordLastModifiedTextLabel.getText() + "</modified>";
		String caption = "<caption>" + logbookRecordTitleTextBox.getText() + "</caption>";
		String author = "<author>" + logbookRecordAuthorTextLabel.getText() + "</author>";
		String category = "";
		try {category = "<category>" + logbookCategoryListBox.getItemText(logbookCategoryListBox.getSelectedIndex()) + "</category>";}
		catch (Exception e) {category = "<category></category>";}
		String importance = "";
		try {importance = "<importance>" + logbookImportanceListBox.getItemText(logbookImportanceListBox.getSelectedIndex()) + "</importance>";}
		catch (Exception e) {importance = "<importance></importance>";}
		String text = "<text>" + logbookRecordTextRichTextArea.getText() + "</text>";
		
		return "<record>" + index + created + modified + caption + author + category + importance + text + "</record>";
	}
	
	/**
	 * Decodes a string (XML) containing all record-specific data (caption, author etc.) and updates the corresponding HTML field values
	 * @param record record as string (XML)
	 */
	private void decodeRecordString(String record) {

		recordIndex = parseString(record, "index");
		logbookRecordCreatedTextLabel.setText(parseString(record, "created"));
		logbookRecordLastModifiedTextLabel.setText(parseString(record, "modified"));
		logbookRecordTitleTextBox.setText(parseString(record, "caption"));
		logbookRecordAuthorTextLabel.setText(parseString(record, "author"));
		for (int i = 0; i < logbookCategoryListBox.getItemCount(); i++) {
			if (logbookCategoryListBox.getValue(i).equals(parseString(record, "category"))) logbookCategoryListBox.setSelectedIndex(i);
		}
		for (int i = 0; i < logbookImportanceListBox.getItemCount(); i++) {
			if (logbookImportanceListBox.getValue(i).equals(parseString(record, "importance"))) logbookImportanceListBox.setSelectedIndex(i);
		}
		logbookRecordTextRichTextArea.setText(parseString(record, "text"));
	}
	
	/**
	 * Parses a string and finds the value associated with the key specified
	 * @param string string to be parsed
	 * @parameter key key string
	 * @return value
	 */
	private String parseString(String string, String key) {
		
		if (string.contains(key)) {
			String value = string.replace("<record>", "").replace("</record>", "").split("<" + key + ">")[1].split("</" + key + ">")[0];
			return value;
		}
		else {
			String value = "";
			return value;
		}
	}
	
	/**
	 * Enables / disables the append-record mode
	 */
	private void changeAppendRecordMode() {
		
		if (recordIndex.equals("-1")) {
			logbookEditRecordButton.setEnabled(false);
			logbookDeleteRecordButton.setEnabled(false);
			logbookRefreshRecordButton.setEnabled(false);
			logbookFirstRecordButton.setEnabled(false);
			logbookPreviousRecordButton.setEnabled(false);
			logbookNextRecordButton.setEnabled(false);
			logbookMostRecentRecordButton.setEnabled(false);
			logbookRecordTextRichTextArea.setText("Enter text here ...");
			logbookRecordLastModifiedTextLabel.setText("");
			logbookRecordCreatedTextLabel.setText("");
			logbookRecordAuthorTextLabel.setText("");
		}
		else {
			logbookEditRecordButton.setEnabled(true);
			logbookDeleteRecordButton.setEnabled(true);
			logbookRefreshRecordButton.setEnabled(true);
			logbookFirstRecordButton.setEnabled(true);
			logbookPreviousRecordButton.setEnabled(true);
			logbookNextRecordButton.setEnabled(true);
			logbookMostRecentRecordButton.setEnabled(true);
		}
	}
	
	/** 
	 * Clears the record input mask
	 */
	private void clearRecordInputMask() {

		logbookRecordCreatedTextLabel.setText("");
		logbookRecordLastModifiedTextLabel.setText("");
		logbookRecordTitleTextBox.setText("");
		logbookRecordAuthorTextLabel.setText(""); 
		logbookCategoryListBox.setSelectedIndex(0);
		logbookImportanceListBox.setSelectedIndex(0);
		logbookRecordTextRichTextArea.setText("Enter text here ...");
		recordIndex = "-1";
		changeAppendRecordMode();
	}
	
	/**
	 * Returns the Web2c session id attached to this page stored in the hidden HTML field "sessionId".
	 * @return session id
	 */
	public native String getSessionId() 
	/*-{
		return $doc.getElementById("sessionId").value;
	}-*/;

	/**
	 * Returns the logbook name attached to this page stored in the hidden HTML field "logbookName".
	 * @return logbook name
	 */
	public native String getLogbookName() 
	/*-{
		return $doc.getElementById("logbookName").value;
	}-*/;
}
