package de.desy.web2cToolkit.web2cLogbook.web2cGWT.server;

import de.desy.web2cToolkit.web2cLogbook.web2cGWT.client.IWeb2cLogbookViewerRemoteService;
import de.desy.web2cToolkit.web2cUtil.web2cInterfaces.IWeb2cConstants;
import de.desy.web2cToolkit.web2cUtil.web2cLifeCycleControl.Web2cContextHandler;
import com.google.gwt.user.server.rpc.RemoteServiceServlet;

/**
 * Logbook Viewer GWT Page Remote Service (Server)
 * @author R.Bacher, DESY
 */
@SuppressWarnings("serial")
public class Web2cLogbookViewerRemoteService extends RemoteServiceServlet implements IWeb2cLogbookViewerRemoteService, IWeb2cConstants {

	public String getRecord(String sessionId, String fileName, String recordIndex) {
		
		return Web2cContextHandler.getInstance(getServletContext()).getWeb2cSessionHandler("Web2cLogbook", sessionId).getWeb2cLogbookPage().doAction("<do>getRecord</do><parameter>" + fileName + "</parameter><parameter>" + recordIndex + "</parameter>");
	}

	public String getFirstRecord(String sessionId, String fileName, String recordIndex) {
		
		return Web2cContextHandler.getInstance(getServletContext()).getWeb2cSessionHandler("Web2cLogbook", sessionId).getWeb2cLogbookPage().doAction("<do>getFirstRecord</do><parameter>" + fileName + "</parameter><parameter>" + recordIndex + "</parameter>");
	}

	public String getPreviousRecord(String sessionId, String fileName, String recordIndex) {
		
		return Web2cContextHandler.getInstance(getServletContext()).getWeb2cSessionHandler("Web2cLogbook", sessionId).getWeb2cLogbookPage().doAction("<do>getPreviousRecord</do><parameter>" + fileName + "</parameter><parameter>" + recordIndex + "</parameter>");
	}

	public String getNextRecord(String sessionId, String fileName, String recordIndex) {
		
		return Web2cContextHandler.getInstance(getServletContext()).getWeb2cSessionHandler("Web2cLogbook", sessionId).getWeb2cLogbookPage().doAction("<do>getNextRecord</do><parameter>" + fileName + "</parameter><parameter>" + recordIndex + "</parameter>");
	}

	public String getMostRecentRecord(String sessionId, String fileName, String recordIndex) {
		
		return Web2cContextHandler.getInstance(getServletContext()).getWeb2cSessionHandler("Web2cLogbook", sessionId).getWeb2cLogbookPage().doAction("<do>getMostRecentRecord</do><parameter>" + fileName + "</parameter><parameter>" + recordIndex + "</parameter>");
	}

	public String editRecord(String sessionId, String fileName, String recordIndex, String record) {
		
		return Web2cContextHandler.getInstance(getServletContext()).getWeb2cSessionHandler("Web2cLogbook", sessionId).getWeb2cLogbookPage().doAction("<do>editRecord</do><parameter>" + fileName + "</parameter><parameter>" + recordIndex + "</parameter><parameter>" + record + "</parameter>");
	}

	public String deleteRecord(String sessionId, String fileName, String recordIndex, String record) {
		
		return Web2cContextHandler.getInstance(getServletContext()).getWeb2cSessionHandler("Web2cLogbook", sessionId).getWeb2cLogbookPage().doAction("<do>deleteRecord</do><parameter>" + fileName + "</parameter><parameter>" + recordIndex + "</parameter><parameter>" + record + "</parameter>");
	}

	public String appendRecord(String sessionId, String fileName, String record) {
		
		return Web2cContextHandler.getInstance(getServletContext()).getWeb2cSessionHandler("Web2cLogbook", sessionId).getWeb2cLogbookPage().doAction("<do>appendRecord</do><parameter>" + fileName + "</parameter><parameter>" + record + "</parameter>");
	}

	public void sendNotification(String sessionId, String fileName, String recordIndex, String address) {
		
		Web2cContextHandler.getInstance(getServletContext()).getWeb2cSessionHandler("Web2cLogbook", sessionId).getWeb2cLogbookPage().doAction("<do>sendNotification</do><parameter>" + fileName + "</parameter><parameter>" + recordIndex + "</parameter><parameter>" + address + "</parameter>");
	}

	public String getLogbookTree(String sessionId) {
		
		return Web2cContextHandler.getInstance(getServletContext()).getWeb2cSessionHandler("Web2cLogbook", sessionId).getWeb2cLogbookPage().doAction("<do>getLogbookTree</do><parameter></parameter>");
	}

	public String getRecipients(String sessionId) {
		
		return Web2cContextHandler.getInstance(getServletContext()).getWeb2cSessionHandler("Web2cLogbook", sessionId).getWeb2cLogbookPage().doAction("<do>getRecipientList</do><parameter></parameter>");
	}

	public String getCategoryKeywords(String sessionId) {
		
		return Web2cContextHandler.getInstance(getServletContext()).getWeb2cSessionHandler("Web2cLogbook", sessionId).getWeb2cLogbookPage().doAction("<do>getCategoryList</do><parameter></parameter>");
	}

	public String getImportanceLevels(String sessionId) {
		
		return Web2cContextHandler.getInstance(getServletContext()).getWeb2cSessionHandler("Web2cLogbook", sessionId).getWeb2cLogbookPage().doAction("<do>getImportanceList</do><parameter></parameter>");
	}

	public String getReportList(String sessionId) {
		
		return Web2cContextHandler.getInstance(getServletContext()).getWeb2cSessionHandler("Web2cLogbook", sessionId).getWeb2cLogbookPage().doAction("<do>getReportList</do><parameter></parameter>");
	}

	public String writeReport(String sessionId, String reportName) {
		
		return Web2cContextHandler.getInstance(getServletContext()).getWeb2cSessionHandler("Web2cLogbook", sessionId).getWeb2cLogbookPage().doAction("<do>generateReport</do><parameter>" + reportName + "</parameter>");
	}
}
