package de.desy.web2cToolkit.web2cManager.web2cGWT.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.user.client.Timer;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.RootPanel;
import de.desy.web2cToolkit.web2cManager.web2cGWT.client.IWeb2cManagerRemoteService.Util;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.TabPanel;
import com.google.gwt.user.client.ui.AbsolutePanel;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.user.client.ui.Frame;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ValueBoxBase.TextAlignment;
import com.google.gwt.user.client.ui.PasswordTextBox;
import com.google.gwt.user.client.ui.TextArea;

/**
 * Manager GWT Page (will be cross-compiled to HTML-Tags, CSS-Tags and JavaScript code by GWT Compiler)
 * @author R.Bacher, DESY
 */
public class Web2cManagerPage implements EntryPoint {

	private RootPanel managerPageRootPanel = null;
	private AbsolutePanel managerPagePanel = null;
	private TabPanel managerPageTabPanel = null;
	private Label managerPageHeader = null;
	
	private AbsolutePanel toolkitConfigurationPanel = null;
	private TextBox toolkitSalutationTextBox = null;
	private Label toolkitSalutationLabel = null;
	private Label toolkitEarlyRegisteringLabel = null;
	private ListBox toolkitAllFilesListBox = null;
	private ListBox toolkitSelectedFilesListBox = null;
	private Button toolkitAddFileButton = null;
	private Button toolkitRemoveFileButton = null;
	private Button toolkitInitializationParametersSetAndSaveButton = null;
	private Label toolkitInitializationParametersLabel = null;
	private Label toolkitUserRegistryLabel = null;
	private TextBox toolkitUserNameTextBox = null;
	private PasswordTextBox toolkitPasswordTextBox1 = null;
	private PasswordTextBox toolkitPasswordTextBox2 = null;
	private Label toolkitRegisteredUsersLabel = null;
	private ListBox toolkitUserListBox = null;
	private Label toolkitUserNameLabel = null;
	private Label toolkitPasswordLabel = null;
	private Button toolkitUserRegistrySetAndSaveButton = null;
	private Button toolkitUserRegistryRemoveAndSaveButton = null;
	private Label toolkitInitializationFilesLabel = null;
	private TextBox toolkitInitializationFileNameTextBox = null;
	private ListBox toolkitInitializationFileTypesListBox = null;
	private Button toolkitInitializationFilesSetAndSaveButton = null;
	private Label toolkitInitializationFileTypesLabel = null;
	private Label toolkitInitializationfileNameLabel = null;
	
	private AbsolutePanel servletDiagnosticsPanel = null;
	private Frame servletDiagnosticsPageFrame = null;
	private ListBox servletDiagnosticsServletListBox = null;
	private Label servletDiagnosticsSelectServletLabel = null;
	
	private AbsolutePanel performancePanel = null;
	private Label performanceGarbageCollectionLabel = null;				
	private Label performanceJvmPerformanceLabel = null;
	private Label performanceJavaGcLabel = null;
	private Label performanceWebcGcLabel = null;
	private Label performanceHeapSpaceLabel = null;
	private Label performanceCpuUsageLabel = null;
	private Label performanceTotaClassCountLabell = null;
	private Label performanceLoadedClassCountLabel;
	private Label performanceHeapSpaceValueLabel = null;
	private Label performanceCpuUsageValueLabel = null;
	private Label performanceTotalClassCountValueLabel = null;
	private ListBox performanceJavaGcListBox = null;
	private ListBox performanceWeb2cGcListBox = null;
	private Button performanceJavaGcSetButton = null;
	private Button performanceWeb2cGcSetButton = null;
	private Button performanceDoJavaGcButton = null;
	private Button performanceDoWeb2cGcButton = null;
	
	private AbsolutePanel debugPanel = null;
	private Label debugLabel = null;
	private Label debugWebCommunicationLabel = null;
	private Label debugControlSystemCommunicationLabel = null;
	private Label debugConfigurationFileParsingLabel = null;
	private ListBox debugWebCommunicationListBox = null;
	private ListBox debugControlSystemCommunicationListBox = null;
	private ListBox debugConfigurationFileParsingListBox = null;
	private Label debugLoggingLabel = null;
	private Label debugLogFilesLabel = null;
	private ListBox debugLogFilesListBox = null;
	private Label debugNumberOfLinesLabel = null;
	private ListBox debugNumberOfLinesListBox = null;
	private TextArea debugLogFileTextArea = null;
	private Button debugGetLogFileButton = null;
	private Button debugClearButton = null;
	
	private AbsolutePanel twitterConfigurationPanel = null;
	private Label twitterIdLabel = null;
	private Label twitterPasswordLabel = null;
	private Label twitterLoggingLabel = null;
	private TextBox twitterIdTextBox = null;
	private PasswordTextBox twitterPasswordTextBox1 = null;
	private PasswordTextBox twitterPasswordTextBox2 = null;
	private ListBox twitterLoggingListBox = null;
	private Button twitterInitParamsSetButton = null;
	private Button twitterInitFileSaveButton = null;
	private TextBox twitterControlTextBox = null;
	private Button twitterServiceRequestPermitButton = null;
	private Button twitterStartServiceButton = null;
	private Button twitterStopServiceButton = null;
	private Label twitterServiceAvailableLabel = null;
	private Label twitterServicePublishingStartedLabel = null;
	private Label twitterServiceMostRecentStatusLabel = null;
	private TextBox twitterServiceAvailableTextBox = null;
	private TextBox twitterServicePublishingStartedTextBox = null;
	private TextBox twitterServiceMostRecentStatusTextBox = null;
	private Button twitterServiceStatusUpdateButton = null;
	private Button twitterArmServiceButton = null;
	private Button twitterDisarmServiceButton = null;
	private Label twitterServiceLabel = null;
	private Label twitterServiceInitializationParametersLabel = null;
	private Label twitterServiceControlLabel = null;
	private Label twitterServiceStatusLabel = null;
	
	private AbsolutePanel smtpConfigurationPanel = null;
	private Label smtpIdLabel = null;
	private Label smtpPasswordLabel = null;
	private Label smtpLoggingLabel = null;
	private TextBox smtpIdTextBox = null;
	private PasswordTextBox smtpPasswordTextBox1 = null;
	private PasswordTextBox smtpPasswordTextBox2 = null;
	private Label smtpHostLabel = null;
	private TextBox smtpHostTextBox = null;
	private ListBox smtpLoggingListBox = null;
	private Button smtpInitParamsSetButton = null;
	private Button smtpInitFileSaveButton = null;
	private TextBox smtpStatusTextBox = null;
	private Label smtpServiceAvailableLabel = null;
	private TextBox smtpServiceAvailableTextBox = null;
	private Button smtpServiceStatusUpdateButton = null;
	private Button smtpArmServiceButton = null;
	private Button smtpDisarmServiceButton = null;
	private Label smtpServiceLabel = null;
	private Label smtpServiceInitializationParametersLabel = null;
	private Label smtpServiceControlLabel = null;
	private Label smtpServiceStatusLabel = null;
	
	private AbsolutePanel logbookConfigurationPanel = null;
	
	private Timer updateTimer = null;

	private IWeb2cManagerRemoteServiceAsync managerRemoteService = null;
	
	/**
	 * Defines and initializes the manger GWT Page
	 */
	public void onModuleLoad() {
	
		managerPageRootPanel = RootPanel.get();
		
		managerPagePanel = new AbsolutePanel();
		managerPageRootPanel.add(managerPagePanel, 10, 92);
		managerPagePanel.setSize("1225px", "806px");
		
			managerPageTabPanel = new TabPanel();
			managerPagePanel.add(managerPageTabPanel, 10, 10);
			managerPageTabPanel.setSize("1205px", "737px");
			
			managerPageHeader = new Label("Web2cManager Page");
			managerPageHeader.setStyleName("gwt-ManagerPageHeader");
			managerPageRootPanel.add(managerPageHeader, 401, 42);
			managerPageHeader.setSize("436px", "21px");
			managerPageHeader.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_CENTER);
			
			// web2cToolkitConfigurationPanel				
			toolkitConfigurationPanel = new AbsolutePanel();
			managerPageTabPanel.add(toolkitConfigurationPanel, "Toolkit Configuration", false);
			toolkitConfigurationPanel.setSize("1080px", "704px");
			
				toolkitSalutationTextBox = new TextBox();
				toolkitSalutationTextBox.setDirectionEstimator(false);
				toolkitSalutationTextBox.setAlignment(TextAlignment.LEFT);
				toolkitSalutationTextBox.setVisibleLength(200);
				toolkitConfigurationPanel.add(toolkitSalutationTextBox, 164, 226);
				toolkitSalutationTextBox.setSize("684px", "30px");
				
				toolkitSalutationLabel = new Label("Salutation:");
				toolkitSalutationLabel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_LEFT);
				toolkitConfigurationPanel.add(toolkitSalutationLabel, 28, 226);
				toolkitSalutationLabel.setSize("102px", "30px");
				
				toolkitEarlyRegisteringLabel = new Label("EarlyRegistering:");
				toolkitEarlyRegisteringLabel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_LEFT);
				toolkitConfigurationPanel.add(toolkitEarlyRegisteringLabel, 28, 342);
				toolkitEarlyRegisteringLabel.setSize("102px", "21px");
				
				toolkitAllFilesListBox = new ListBox();
				toolkitAllFilesListBox.setVisibleItemCount(10);
				toolkitConfigurationPanel.add(toolkitAllFilesListBox, 164, 293);
				toolkitAllFilesListBox.setSize("269px", "147px");
				
				toolkitSelectedFilesListBox = new ListBox();
				toolkitSelectedFilesListBox.setVisibleItemCount(10);
				toolkitConfigurationPanel.add(toolkitSelectedFilesListBox, 589, 293);
				toolkitSelectedFilesListBox.setSize("269px", "147px");
				
				toolkitAddFileButton = new Button("");
				toolkitAddFileButton.setText("Add");
				toolkitConfigurationPanel.add(toolkitAddFileButton, 468, 316);
				toolkitAddFileButton.setSize("85px", "30px");
				
				toolkitRemoveFileButton = new Button("");
				toolkitRemoveFileButton.setText("Remove");
				toolkitConfigurationPanel.add(toolkitRemoveFileButton, 468, 377);
				toolkitRemoveFileButton.setSize("85px", "30px");
				
				toolkitInitializationParametersSetAndSaveButton = new Button("");
				toolkitInitializationParametersSetAndSaveButton.setText("Set & Save");
				toolkitConfigurationPanel.add(toolkitInitializationParametersSetAndSaveButton, 905, 289);
				toolkitInitializationParametersSetAndSaveButton.setSize("140px", "35px");
				
				toolkitInitializationParametersLabel = new Label("Initialization Parameters");
				toolkitInitializationParametersLabel.setStyleName("gwt-SelectServletLabel");
				toolkitConfigurationPanel.add(toolkitInitializationParametersLabel, 10, 172);
				toolkitInitializationParametersLabel.setSize("222px", "18px");
				
				toolkitUserRegistryLabel = new Label("User Registry");
				toolkitUserRegistryLabel.setStyleName("gwt-SelectServletLabel");
				toolkitConfigurationPanel.add(toolkitUserRegistryLabel, 10, 458);
				toolkitUserRegistryLabel.setSize("222px", "18px");
				
				toolkitUserNameTextBox = new TextBox();
				toolkitUserNameTextBox.setVisibleLength(200);
				toolkitUserNameTextBox.setDirectionEstimator(false);
				toolkitUserNameTextBox.setAlignment(TextAlignment.LEFT);
				toolkitConfigurationPanel.add(toolkitUserNameTextBox, 500, 505);
				toolkitUserNameTextBox.setSize("348px", "30px");
				
				toolkitPasswordTextBox1 = new PasswordTextBox();
				toolkitPasswordTextBox1.setVisibleLength(100);
				toolkitConfigurationPanel.add(toolkitPasswordTextBox1, 500, 576);
				toolkitPasswordTextBox1.setSize("348px", "33px");
				
				toolkitPasswordTextBox2 = new PasswordTextBox();
				toolkitPasswordTextBox2.setVisibleLength(100);
				toolkitConfigurationPanel.add(toolkitPasswordTextBox2, 500, 630);
				toolkitPasswordTextBox2.setSize("348px", "33px");
				
				toolkitRegisteredUsersLabel = new Label("Registered Users:");
				toolkitConfigurationPanel.add(toolkitRegisteredUsersLabel, 28, 568);
				toolkitRegisteredUsersLabel.setSize("125px", "21px");
				
				toolkitUserListBox = new ListBox();
				toolkitUserListBox.setSelectedIndex(0);
				toolkitUserListBox.setVisibleItemCount(10);
				toolkitConfigurationPanel.add(toolkitUserListBox, 173, 505);
				toolkitUserListBox.setSize("192px", "170px");
				
				toolkitUserNameLabel = new Label("Name:");
				toolkitConfigurationPanel.add(toolkitUserNameLabel, 399, 517);
				toolkitUserNameLabel.setSize("75px", "18px");
				
				toolkitPasswordLabel = new Label("Password:");
				toolkitConfigurationPanel.add(toolkitPasswordLabel, 399, 615);
				toolkitPasswordLabel.setSize("75px", "18px");
				
				toolkitUserRegistrySetAndSaveButton = new Button("");
				toolkitUserRegistrySetAndSaveButton.setText("Set & Save");
				toolkitConfigurationPanel.add(toolkitUserRegistrySetAndSaveButton, 905, 551);
				toolkitUserRegistrySetAndSaveButton.setSize("140px", "35px");
				
				toolkitUserRegistryRemoveAndSaveButton = new Button("");
				toolkitUserRegistryRemoveAndSaveButton.setText("Remove & Save");
				toolkitConfigurationPanel.add(toolkitUserRegistryRemoveAndSaveButton, 905, 615);
				toolkitUserRegistryRemoveAndSaveButton.setSize("140px", "35px");
				
				toolkitInitializationFilesLabel = new Label("Initialization Files");
				toolkitInitializationFilesLabel.setStyleName("gwt-SelectServletLabel");
				toolkitConfigurationPanel.add(toolkitInitializationFilesLabel, 10, 10);
				toolkitInitializationFilesLabel.setSize("222px", "18px");
				
				toolkitInitializationFileNameTextBox = new TextBox();
				toolkitInitializationFileNameTextBox.setVisibleLength(200);
				toolkitInitializationFileNameTextBox.setDirectionEstimator(false);
				toolkitInitializationFileNameTextBox.setAlignment(TextAlignment.LEFT);
				toolkitConfigurationPanel.add(toolkitInitializationFileNameTextBox, 418, 66);
				toolkitInitializationFileNameTextBox.setSize("430px", "30px");
				
				toolkitInitializationFileTypesListBox = new ListBox();
				toolkitInitializationFileTypesListBox.setSelectedIndex(0);
				toolkitInitializationFileTypesListBox.setVisibleItemCount(5);
				toolkitConfigurationPanel.add(toolkitInitializationFileTypesListBox, 111, 44);
				toolkitInitializationFileTypesListBox.setSize("192px", "101px");
				
				toolkitInitializationFilesSetAndSaveButton = new Button("");
				toolkitInitializationFilesSetAndSaveButton.setText("Set & Save");
				toolkitConfigurationPanel.add(toolkitInitializationFilesSetAndSaveButton, 905, 66);
				toolkitInitializationFilesSetAndSaveButton.setSize("140px", "35px");
				
				toolkitInitializationFileTypesLabel = new Label("Tpye:");
				toolkitInitializationFileTypesLabel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_LEFT);
				toolkitConfigurationPanel.add(toolkitInitializationFileTypesLabel, 28, 78);
				toolkitInitializationFileTypesLabel.setSize("70px", "30px");
				
				toolkitInitializationfileNameLabel = new Label("Name:");
				toolkitInitializationfileNameLabel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_LEFT);
				toolkitConfigurationPanel.add(toolkitInitializationfileNameLabel, 342, 80);
				toolkitInitializationfileNameLabel.setSize("70px", "21px");
			
			// servletDiagnosticsPanel
			servletDiagnosticsPanel = new AbsolutePanel();
			managerPageTabPanel.add(servletDiagnosticsPanel, "Toolkit Diagnostics", false);
			servletDiagnosticsPanel.setSize("1190px", "699px");
				
					servletDiagnosticsPageFrame = new Frame();
					servletDiagnosticsPanel.add(servletDiagnosticsPageFrame, 10, 78);
					servletDiagnosticsPageFrame.setSize("1166px", "607px");
					
					servletDiagnosticsServletListBox = new ListBox();
					servletDiagnosticsServletListBox.setSelectedIndex(0);
					servletDiagnosticsServletListBox.setSize("395px", "62px");
					servletDiagnosticsServletListBox.setVisibleItemCount(5);
					servletDiagnosticsPanel.add(servletDiagnosticsServletListBox, 397, 10);
					
					servletDiagnosticsSelectServletLabel = new Label("Select servlet:");
					servletDiagnosticsSelectServletLabel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_CENTER);
					servletDiagnosticsSelectServletLabel.setStyleName("gwt-SelectServletLabel");
					servletDiagnosticsPanel.add(servletDiagnosticsSelectServletLabel, 58, 20);
					servletDiagnosticsSelectServletLabel.setSize("268px", "31px");
			
			// performancePanel
			performancePanel = new AbsolutePanel();
			managerPageTabPanel.add(performancePanel, "Toolkit Performance", false);
			performancePanel.setSize("1174px", "696px");
			
				performanceGarbageCollectionLabel = new Label("Garbage Collection");
				performanceGarbageCollectionLabel.setStyleName("gwt-SelectServletLabel");
				performancePanel.add(performanceGarbageCollectionLabel, 23, 33);
				performanceGarbageCollectionLabel.setSize("222px", "18px");
				
				performanceJvmPerformanceLabel = new Label("JVM Performance");
				performanceJvmPerformanceLabel.setStyleName("gwt-SelectServletLabel");
				performancePanel.add(performanceJvmPerformanceLabel, 23, 348);
				performanceJvmPerformanceLabel.setSize("222px", "18px");
				
				performanceJavaGcLabel = new Label("Java garbage collection (default = off)");
				performancePanel.add(performanceJavaGcLabel, 41, 100);
				performanceJavaGcLabel.setSize("332px", "28px");
				
				performanceWebcGcLabel = new Label("Web2c garbage collection (default = on)");
				performanceWebcGcLabel.setStyleName("gwt-DialogBox .Caption");
				performancePanel.add(performanceWebcGcLabel, 41, 174);
				performanceWebcGcLabel.setSize("332px", "28px");
				
				performanceHeapSpaceLabel = new Label("Heap space usage [%]:");
				performancePanel.add(performanceHeapSpaceLabel, 41, 411);
				performanceHeapSpaceLabel.setSize("247px", "28px");
				
				performanceCpuUsageLabel = new Label("CPU usage [%]:");
				performancePanel.add(performanceCpuUsageLabel, 41, 476);
				performanceCpuUsageLabel.setSize("247px", "28px");
				
				performanceLoadedClassCountLabel = new Label("Number of classes loaded:");
				performancePanel.add(performanceLoadedClassCountLabel, 41, 535);
				performanceLoadedClassCountLabel.setSize("247px", "28px");
				
				performanceHeapSpaceValueLabel = new Label("0");
				performanceHeapSpaceValueLabel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_RIGHT);
				performancePanel.add(performanceHeapSpaceValueLabel, 292, 411);
				performanceHeapSpaceValueLabel.setSize("56px", "28px");
				
				performanceCpuUsageValueLabel = new Label("0");
				performanceCpuUsageValueLabel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_RIGHT);
				performancePanel.add(performanceCpuUsageValueLabel, 294, 476);
				performanceCpuUsageValueLabel.setSize("56px", "28px");
				
				performanceTotalClassCountValueLabel = new Label("0");
				performanceTotalClassCountValueLabel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_RIGHT);
				performancePanel.add(performanceTotalClassCountValueLabel, 294, 535);
				performanceTotalClassCountValueLabel.setSize("56px", "28px");
				
				performanceJavaGcListBox = new ListBox();
				performanceJavaGcListBox.addItem("on");
				performanceJavaGcListBox.addItem("off");
				performancePanel.add(performanceJavaGcListBox, 391, 100);
				performanceJavaGcListBox.setSize("56px", "46px");
				performanceJavaGcListBox.setVisibleItemCount(2);
				
				performanceWeb2cGcListBox = new ListBox();
				performanceWeb2cGcListBox.addItem("on");
				performanceWeb2cGcListBox.addItem("off");
				performanceWeb2cGcListBox.setVisibleItemCount(2);
				performancePanel.add(performanceWeb2cGcListBox, 391, 174);
				performanceWeb2cGcListBox.setSize("56px", "46px");
				
				performanceJavaGcSetButton = new Button("");
				performanceJavaGcSetButton.setText("Set");
				performancePanel.add(performanceJavaGcSetButton, 548, 100);
				performanceJavaGcSetButton.setSize("100px", "46px");
				
				performanceWeb2cGcSetButton = new Button("");
				performanceWeb2cGcSetButton.setText("Set");
				performancePanel.add(performanceWeb2cGcSetButton, 548, 174);
				performanceWeb2cGcSetButton.setSize("100px", "46px");
				
				performanceDoJavaGcButton = new Button("");
				performanceDoJavaGcButton.setText("Do Garbage Collection now");
				performancePanel.add(performanceDoJavaGcButton, 818, 100);
				performanceDoJavaGcButton.setSize("212px", "46px");
			
			// debugPanel
			debugPanel = new AbsolutePanel();
			managerPageTabPanel.add(debugPanel, "Toolkit Debug & Logging", false);
			debugPanel.setSize("1199px", "702px");
			
				debugLabel = new Label("Debug Flags");
				debugLabel.setStyleName("gwt-SelectServletLabel");
				debugPanel.add(debugLabel, 10, 27);
				debugLabel.setSize("222px", "18px");
				
				debugWebCommunicationLabel = new Label("Web Communication:");
				debugPanel.add(debugWebCommunicationLabel, 28, 87);
				debugWebCommunicationLabel.setSize("159px", "18px");
				
				debugControlSystemCommunicationLabel = new Label("Control System Communication:");
				debugPanel.add(debugControlSystemCommunicationLabel, 387, 87);
				debugControlSystemCommunicationLabel.setSize("239px", "18px");
				
				debugConfigurationFileParsingLabel = new Label("Configuration File Parsing:");
				debugPanel.add(debugConfigurationFileParsingLabel, 822, 87);
				debugConfigurationFileParsingLabel.setSize("218px", "18px");
				
				debugWebCommunicationListBox = new ListBox();
				debugWebCommunicationListBox.addItem("yes");
				debugWebCommunicationListBox.addItem("no");
				debugWebCommunicationListBox.setVisibleItemCount(2);
				debugPanel.add(debugWebCommunicationListBox, 193, 75);
				debugWebCommunicationListBox.setSize("95px", "56px");
				
				debugControlSystemCommunicationListBox = new ListBox();
				debugControlSystemCommunicationListBox.addItem("yes");
				debugControlSystemCommunicationListBox.addItem("no");
				debugControlSystemCommunicationListBox.setVisibleItemCount(2);
				debugPanel.add(debugControlSystemCommunicationListBox, 643, 75);
				debugControlSystemCommunicationListBox.setSize("95px", "56px");
				
				debugConfigurationFileParsingListBox = new ListBox();
				debugConfigurationFileParsingListBox.addItem("yes");
				debugConfigurationFileParsingListBox.addItem("no");
				debugConfigurationFileParsingListBox.setVisibleItemCount(2);
				debugPanel.add(debugConfigurationFileParsingListBox, 1055, 75);
				debugConfigurationFileParsingListBox.setSize("95px", "56px");
				
				debugLoggingLabel = new Label("Logging");
				debugLoggingLabel.setStyleName("gwt-SelectServletLabel");
				debugPanel.add(debugLoggingLabel, 10, 154);
				debugLoggingLabel.setSize("222px", "18px");
				
				debugLogFilesLabel = new Label("Log Files:");
				debugPanel.add(debugLogFilesLabel, 28, 242);
				debugLogFilesLabel.setSize("83px", "18px");
				
				debugLogFilesListBox = new ListBox();
				debugLogFilesListBox.setSelectedIndex(0);
				debugLogFilesListBox.setVisibleItemCount(5);
				debugPanel.add(debugLogFilesListBox, 135, 202);
				debugLogFilesListBox.setSize("280px", "130px");
				
				debugNumberOfLinesLabel = new Label("Number of Lines:");
				debugPanel.add(debugNumberOfLinesLabel, 459, 242);
				debugNumberOfLinesLabel.setSize("118px", "18px");
				
				debugNumberOfLinesListBox = new ListBox();
				debugNumberOfLinesListBox.addItem("All");
				debugNumberOfLinesListBox.addItem("100");
				debugNumberOfLinesListBox.addItem("200");
				debugNumberOfLinesListBox.addItem("300");
				debugNumberOfLinesListBox.addItem("400");
				debugNumberOfLinesListBox.addItem("500");
				debugNumberOfLinesListBox.setVisibleItemCount(5);
				debugPanel.add(debugNumberOfLinesListBox, 611, 202);
				debugNumberOfLinesListBox.setSize("95px", "130px");
				debugNumberOfLinesListBox.setSelectedIndex(0);
				
				debugLogFileTextArea = new TextArea();
				debugLogFileTextArea.setReadOnly(true);
				debugLogFileTextArea.setVisibleLines(20);
				debugPanel.add(debugLogFileTextArea, 28, 353);
				debugLogFileTextArea.setSize("1120px", "314px");
				
				debugGetLogFileButton = new Button("");
				debugGetLogFileButton.setText("Open");
				debugPanel.add(debugGetLogFileButton, 836, 242);
				debugGetLogFileButton.setSize("118px", "35px");
				
				debugClearButton = new Button("");
				debugClearButton.setText("Clear");
				debugPanel.add(debugClearButton, 1032, 242);
				debugClearButton.setSize("118px", "35px");
			
			// twitterConfigurationPanel
			twitterConfigurationPanel = new AbsolutePanel();
			managerPageTabPanel.add(twitterConfigurationPanel, "Twitter Service", false);
			twitterConfigurationPanel.setSize("1110px", "704px");
			
				twitterIdLabel = new Label("id:");
				twitterConfigurationPanel.add(twitterIdLabel, 60, 80);
				twitterIdLabel.setSize("67px", "18px");
				
					twitterPasswordLabel = new Label("password:");
					twitterConfigurationPanel.add(twitterPasswordLabel, 60, 168);
					twitterPasswordLabel.setSize("59px", "18px");
					
					twitterLoggingLabel = new Label("logging:");
					twitterConfigurationPanel.add(twitterLoggingLabel, 60, 257);
					
					twitterIdTextBox = new TextBox();
					twitterIdTextBox.setVisibleLength(100);
					twitterConfigurationPanel.add(twitterIdTextBox, 165, 62);
					twitterIdTextBox.setSize("906px", "40px");
					
					twitterPasswordTextBox1 = new PasswordTextBox();
					twitterPasswordTextBox1.setVisibleLength(100);
					twitterConfigurationPanel.add(twitterPasswordTextBox1, 165, 134);
					twitterPasswordTextBox1.setSize("906px", "33px");
					
					twitterPasswordTextBox2 = new PasswordTextBox();
					twitterPasswordTextBox2.setVisibleLength(100);
					twitterConfigurationPanel.add(twitterPasswordTextBox2, 165, 185);
					twitterPasswordTextBox2.setSize("906px", "33px");
					
					twitterLoggingListBox = new ListBox();
					twitterLoggingListBox.setVisibleItemCount(2);
					twitterConfigurationPanel.add(twitterLoggingListBox, 165, 247);
					twitterLoggingListBox.setSize("95px", "56px");
					twitterLoggingListBox.addItem("yes");
					twitterLoggingListBox.addItem("no");
					
					twitterInitParamsSetButton = new Button("Set");
					twitterConfigurationPanel.add(twitterInitParamsSetButton, 758, 257);
					twitterInitParamsSetButton.setSize("143px", "35px");
					
					twitterInitFileSaveButton = new Button("Save");
					twitterInitFileSaveButton.setText("Set & Save");
					twitterConfigurationPanel.add(twitterInitFileSaveButton, 941, 257);
					twitterInitFileSaveButton.setSize("140px", "35px");
					
					twitterControlTextBox = new TextBox();
					twitterConfigurationPanel.add(twitterControlTextBox, 60, 423);
					twitterControlTextBox.setSize("1011px", "32px");
					
					twitterServiceRequestPermitButton = new Button("");
					twitterServiceRequestPermitButton.setText(" Step 2: Request Permit to Publish Status");
					twitterConfigurationPanel.add(twitterServiceRequestPermitButton, 377, 341);
					twitterServiceRequestPermitButton.setSize("370px", "35px");
					
					twitterStartServiceButton = new Button("");
					twitterStartServiceButton.setText("Step 3: Start Status Publishing ");
					twitterConfigurationPanel.add(twitterStartServiceButton, 770, 341);
					twitterStartServiceButton.setSize("311px", "35px");
					
					twitterStopServiceButton = new Button("");
					twitterStopServiceButton.setText("Step 4: Stop Status Publishing ");
					twitterConfigurationPanel.add(twitterStopServiceButton, 60, 382);
					twitterStopServiceButton.setSize("295px", "35px");
					
					twitterServiceAvailableLabel = new Label("Service available?");
					twitterConfigurationPanel.add(twitterServiceAvailableLabel, 60, 536);
					twitterServiceAvailableLabel.setSize("173px", "18px");
					
					twitterServicePublishingStartedLabel = new Label("Publishing started?");
					twitterConfigurationPanel.add(twitterServicePublishingStartedLabel, 60, 600);
					twitterServicePublishingStartedLabel.setSize("173px", "18px");
					
					twitterServiceMostRecentStatusLabel = new Label("Most recent status:");
					twitterConfigurationPanel.add(twitterServiceMostRecentStatusLabel, 60, 657);
					twitterServiceMostRecentStatusLabel.setSize("173px", "18px");
					
					twitterServiceAvailableTextBox = new TextBox();
					twitterServiceAvailableTextBox.setReadOnly(true);
					twitterConfigurationPanel.add(twitterServiceAvailableTextBox, 240, 524);
					twitterServiceAvailableTextBox.setSize("74px", "32px");
					
					twitterServicePublishingStartedTextBox = new TextBox();
					twitterServicePublishingStartedTextBox.setReadOnly(true);
					twitterConfigurationPanel.add(twitterServicePublishingStartedTextBox, 240, 587);
					twitterServicePublishingStartedTextBox.setSize("74px", "35px");
					
					twitterServiceMostRecentStatusTextBox = new TextBox();
					twitterServiceMostRecentStatusTextBox.setReadOnly(true);
					twitterConfigurationPanel.add(twitterServiceMostRecentStatusTextBox, 239, 649);
					twitterServiceMostRecentStatusTextBox.setSize("832px", "33px");
					
					twitterServiceStatusUpdateButton = new Button("Update");
					twitterServiceStatusUpdateButton.setText("Update Service Status");
					twitterConfigurationPanel.add(twitterServiceStatusUpdateButton, 547, 555);
					twitterServiceStatusUpdateButton.setSize("256px", "35px");
					
					twitterArmServiceButton = new Button("");
					twitterArmServiceButton.setText("Step 1: Arm Service");
					twitterConfigurationPanel.add(twitterArmServiceButton, 60, 341);
					twitterArmServiceButton.setSize("295px", "35px");
					
					twitterDisarmServiceButton = new Button("");
					twitterDisarmServiceButton.setText("Step 5: Disarm Service");
					twitterConfigurationPanel.add(twitterDisarmServiceButton, 770, 382);
					twitterDisarmServiceButton.setSize("311px", "35px");
					
					twitterServiceLabel = new Label("");
					twitterConfigurationPanel.add(twitterServiceLabel, 61, 23);
					twitterServiceLabel.setSize("44px", "18px");
					
					twitterServiceInitializationParametersLabel = new Label("Initialization Parameters");
					twitterServiceInitializationParametersLabel.setStyleName("gwt-SelectServletLabel");
					twitterConfigurationPanel.add(twitterServiceInitializationParametersLabel, 10, 23);
					twitterServiceInitializationParametersLabel.setSize("222px", "18px");
					
					twitterServiceControlLabel = new Label("Control");
					twitterServiceControlLabel.setStyleName("gwt-SelectServletLabel");
					twitterConfigurationPanel.add(twitterServiceControlLabel, 10, 296);
					twitterServiceControlLabel.setSize("353px", "18px");
					
					twitterServiceStatusLabel = new Label("Status");
					twitterServiceStatusLabel.setStyleName("gwt-SelectServletLabel");
					twitterConfigurationPanel.add(twitterServiceStatusLabel, 10, 481);
					twitterServiceStatusLabel.setSize("143px", "18px");
					twitterPasswordTextBox2.setSize("906px", "33px");
			
			// smptConfigurationPanel
			smtpConfigurationPanel = new AbsolutePanel();
			managerPageTabPanel.add(smtpConfigurationPanel, "SMTP Service", false);
			smtpConfigurationPanel.setSize("1110px", "704px");
			
				smtpIdLabel = new Label("id:");
				smtpConfigurationPanel.add(smtpIdLabel, 60, 80);
				smtpIdLabel.setSize("67px", "18px");
				
					smtpPasswordLabel = new Label("password:");
					smtpConfigurationPanel.add(smtpPasswordLabel, 60, 168);
					smtpPasswordLabel.setSize("59px", "18px");
					
					smtpLoggingLabel = new Label("logging:");
					smtpConfigurationPanel.add(smtpLoggingLabel, 60, 345);
					
					smtpIdTextBox = new TextBox();
					smtpIdTextBox.setVisibleLength(100);
					smtpConfigurationPanel.add(smtpIdTextBox, 165, 62);
					smtpIdTextBox.setSize("906px", "40px");
					
					smtpPasswordTextBox1 = new PasswordTextBox();
					smtpPasswordTextBox1.setVisibleLength(100);
					smtpConfigurationPanel.add(smtpPasswordTextBox1, 165, 134);
					smtpPasswordTextBox1.setSize("906px", "33px");
					
					smtpPasswordTextBox2 = new PasswordTextBox();
					smtpPasswordTextBox2.setVisibleLength(100);
					smtpConfigurationPanel.add(smtpPasswordTextBox2, 165, 185);
					smtpPasswordTextBox2.setSize("906px", "33px");
					
					smtpHostLabel = new Label("host:");
					smtpConfigurationPanel.add(smtpHostLabel, 60, 263);
					smtpHostLabel.setSize("59px", "18px");
					
					smtpHostTextBox = new TextBox();
					smtpHostTextBox.setVisibleLength(100);
					smtpConfigurationPanel.add(smtpHostTextBox, 165, 250);
					smtpHostTextBox.setSize("906px", "40px");
					
					smtpLoggingListBox = new ListBox();
					smtpLoggingListBox.setVisibleItemCount(2);
					smtpConfigurationPanel.add(smtpLoggingListBox, 165, 328);
					smtpLoggingListBox.setSize("95px", "56px");
					smtpLoggingListBox.addItem("yes");
					smtpLoggingListBox.addItem("no");
					
					smtpInitParamsSetButton = new Button("Set");
					smtpConfigurationPanel.add(smtpInitParamsSetButton, 771, 328);
					smtpInitParamsSetButton.setSize("143px", "35px");
					
					smtpInitFileSaveButton = new Button("Save");
					smtpInitFileSaveButton.setText("Set & Save");
					smtpConfigurationPanel.add(smtpInitFileSaveButton, 941, 328);
					smtpInitFileSaveButton.setSize("140px", "35px");
					
					smtpStatusTextBox = new TextBox();
					smtpConfigurationPanel.add(smtpStatusTextBox, 60, 633);
					smtpStatusTextBox.setSize("1011px", "32px");
					
					smtpServiceAvailableLabel = new Label("Service available?");
					smtpConfigurationPanel.add(smtpServiceAvailableLabel, 60, 574);
					smtpServiceAvailableLabel.setSize("173px", "18px");
					
					smtpServiceAvailableTextBox = new TextBox();
					smtpServiceAvailableTextBox.setReadOnly(true);
					smtpConfigurationPanel.add(smtpServiceAvailableTextBox, 239, 561);
					smtpServiceAvailableTextBox.setSize("74px", "32px");
					
					smtpServiceStatusUpdateButton = new Button("Update");
					smtpServiceStatusUpdateButton.setText("Update Service Status");
					smtpConfigurationPanel.add(smtpServiceStatusUpdateButton, 550, 557);
					smtpServiceStatusUpdateButton.setSize("256px", "35px");
					
					smtpArmServiceButton = new Button("");
					smtpArmServiceButton.setText("Arm Service");
					smtpConfigurationPanel.add(smtpArmServiceButton, 60, 439);
					smtpArmServiceButton.setSize("295px", "35px");
					
					smtpDisarmServiceButton = new Button("");
					smtpDisarmServiceButton.setText("Disarm Service");
					smtpConfigurationPanel.add(smtpDisarmServiceButton, 770, 439);
					smtpDisarmServiceButton.setSize("311px", "35px");
					
					smtpServiceLabel = new Label("");
					smtpConfigurationPanel.add(smtpServiceLabel, 61, 23);
					smtpServiceLabel.setSize("44px", "18px");
					
					smtpServiceInitializationParametersLabel = new Label("Initialization Parameters");
					smtpServiceInitializationParametersLabel.setStyleName("gwt-SelectServletLabel");
					smtpConfigurationPanel.add(smtpServiceInitializationParametersLabel, 10, 23);
					smtpServiceInitializationParametersLabel.setSize("222px", "18px");
					
					smtpServiceControlLabel = new Label("Control");
					smtpServiceControlLabel.setStyleName("gwt-SelectServletLabel");
					smtpConfigurationPanel.add(smtpServiceControlLabel, 10, 390);
					smtpServiceControlLabel.setSize("353px", "18px");
					
					smtpServiceStatusLabel = new Label("Status");
					smtpServiceStatusLabel.setStyleName("gwt-SelectServletLabel");
					smtpConfigurationPanel.add(smtpServiceStatusLabel, 10, 513);
					smtpServiceStatusLabel.setSize("143px", "18px");
			
			// logbookPanel		
			logbookConfigurationPanel = new AbsolutePanel();
			managerPageTabPanel.add(logbookConfigurationPanel, "Logbook Service", false);
			logbookConfigurationPanel.setSize("1174px", "709px");
					
				
		managerRemoteService = Util.getInstance();

		managerRemoteService.getServletNames(new AsyncCallback<String[]>() {
			public void onFailure(Throwable caught) {
			}
				
			public void onSuccess(String[] result) {
				for (int i = 0; i < result.length; i++) servletDiagnosticsServletListBox.addItem(result[i]);
			}
		}); 
		
		managerRemoteService.getJavaGarbageCollection(new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}

			public void onSuccess(String result) {
				if (parseReturnString(result).equals("on")) performanceJavaGcListBox.setSelectedIndex(0);
				if (parseReturnString(result).equals("off")) performanceJavaGcListBox.setSelectedIndex(1);
			}
		}); 
		
		managerRemoteService.getWeb2cToolkitGarbageCollection(new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}

			public void onSuccess(String result) {
				if (parseReturnString(result).equals("on")) performanceWeb2cGcListBox.setSelectedIndex(0);
				if (parseReturnString(result).equals("off")) performanceWeb2cGcListBox.setSelectedIndex(1);
			}
		}); 
		
		managerRemoteService.getPercentagedHeapSpaceUsage(getSessionId(), new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}

			public void onSuccess(String result) {
				performanceHeapSpaceValueLabel.setText(parseReturnString(result));
			}
		}); 
		
		managerRemoteService.getPercentagedCPUUsage(getSessionId(), new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}

			public void onSuccess(String result) {
				performanceCpuUsageValueLabel.setText(parseReturnString(result));
			}
		}); 
		
		managerRemoteService.getLoadedClassCount(getSessionId(), new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}

			public void onSuccess(String result) {
				performanceTotalClassCountValueLabel.setText(parseReturnString(result));
			}
		}); 

		managerRemoteService.getTwitterId(new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}

			public void onSuccess(String result) {
				twitterIdTextBox.setText(result);
			}
		});
		managerRemoteService.getTwitterPassword(new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}

			public void onSuccess(String result) {
				twitterPasswordTextBox1.setText(result);
			}
		}); 
		managerRemoteService.getTwitterPassword(new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}

			public void onSuccess(String result) {
				twitterPasswordTextBox2.setText(result);
			}
		}); 
		managerRemoteService.getTwitterLoggingOption(new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}

			public void onSuccess(String result) {
				for (int i = 0; i < twitterLoggingListBox.getItemCount(); i++) {
					if (twitterLoggingListBox.getItemText(i).equals(result)) twitterLoggingListBox.setSelectedIndex(i);
				}
			}
		}); 
		managerRemoteService.getTwitterServiceStatus(new AsyncCallback<Boolean>() {
			public void onFailure(Throwable caught) {
			}

			public void onSuccess(Boolean result) {
				if (result == true) twitterServiceAvailableTextBox.setText("yes");
				else twitterServiceAvailableTextBox.setText("no");
			}
		}); 
		managerRemoteService.getTwitterPublishingStatus(new AsyncCallback<Boolean>() {
			public void onFailure(Throwable caught) {
			}

			public void onSuccess(Boolean result) {
				if (result == true) twitterServicePublishingStartedTextBox.setText("yes");
				else twitterServicePublishingStartedTextBox.setText("no");
			}
		}); 
		
		managerRemoteService.getMostRecentTwitterStatus(new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}

			public void onSuccess(String result) {
				twitterServiceMostRecentStatusTextBox.setText(result);
			}
		}); 
		
		managerRemoteService.getSMTPId(new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}
	
			public void onSuccess(String result) {
				smtpIdTextBox.setText(result);
			}
		});
		
		managerRemoteService.getSMTPPassword(new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}
	
			public void onSuccess(String result) {
				smtpPasswordTextBox1.setText(result);
			}
		}); 
		
		managerRemoteService.getSMTPPassword(new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}
	
			public void onSuccess(String result) {
				smtpPasswordTextBox2.setText(result);
			}
		}); 
		
		managerRemoteService.getSMTPHost(new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}
	
			public void onSuccess(String result) {
				smtpHostTextBox.setText(result);
			}
		}); 
		
		managerRemoteService.getSMTPLoggingOption(new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}
	
			public void onSuccess(String result) {
				for (int i = 0; i < smtpLoggingListBox.getItemCount(); i++) {
					if (smtpLoggingListBox.getItemText(i).equals(result)) smtpLoggingListBox.setSelectedIndex(i);
				}
			}
		}); 
		
		managerRemoteService.getSMTPServiceStatus(new AsyncCallback<Boolean>() {
			public void onFailure(Throwable caught) {
			}
	
			public void onSuccess(Boolean result) {
				if (result == true) smtpServiceAvailableTextBox.setText("yes");
				else smtpServiceAvailableTextBox.setText("no");
			}
		}); 
		
		managerRemoteService.getSalutationText(new AsyncCallback<String>() {
			public void onFailure(Throwable caught) {
			}
	
			public void onSuccess(String result) {
				toolkitSalutationTextBox.setText(result);
			}
		}); 
		
		managerRemoteService.getAllConfigFileNames(new AsyncCallback<String[]>() {
			public void onFailure(Throwable caught) {
			}
				
			public void onSuccess(String[] result) {
				for (int i = 0; i < result.length; i++) toolkitAllFilesListBox.addItem(result[i]);
			}
		}); 
		
		managerRemoteService.getEarlyRegisteringFiles(new AsyncCallback<String[]>() {
			public void onFailure(Throwable caught) {
			}
	
			public void onSuccess(String[] result) {
				for (int i = 0; i < result.length; i++) toolkitSelectedFilesListBox.addItem(result[i]);
			}
		}); 
		managerRemoteService.getUserNames(new AsyncCallback<String[]>() {
			public void onFailure(Throwable caught) {
			}
				
			public void onSuccess(String[] result) {
				for (int i = 0; i < result.length; i++) toolkitUserListBox.addItem(result[i]);
				toolkitPasswordTextBox1.setText("");
				toolkitPasswordTextBox2.setText("");
			}
		}); 
		
		managerRemoteService.getInitFileTypes(new AsyncCallback<String[]>() {
			public void onFailure(Throwable caught) {
			}
				
			public void onSuccess(String[] result) {
				for (int i = 0; i < result.length; i++) toolkitInitializationFileTypesListBox.addItem(result[i]);
				toolkitInitializationFileNameTextBox.setText("");
			}
		}); 
		
		managerRemoteService.getAllLogFileNames(new AsyncCallback<String[]>() {
			public void onFailure(Throwable caught) {
			}
				
			public void onSuccess(String[] result) {
				for (int i = 0; i < result.length; i++) debugLogFilesListBox.addItem(result[i]);
			}
		}); 

		toolkitAddFileButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {		
				toolkitSelectedFilesListBox.addItem(toolkitAllFilesListBox.getItemText(toolkitAllFilesListBox.getSelectedIndex()));			
			}
		});		

		toolkitRemoveFileButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				toolkitSelectedFilesListBox.removeItem(toolkitSelectedFilesListBox.getSelectedIndex());	
			}
		});

		toolkitInitializationParametersSetAndSaveButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				String[] list = new String[toolkitSelectedFilesListBox.getItemCount()];
				for (int i = 0; i < toolkitSelectedFilesListBox.getItemCount(); i++) list[i] = toolkitSelectedFilesListBox.getValue(i);
				managerRemoteService.saveToolkitInitializationParameters(toolkitSalutationTextBox.getText(), list, new AsyncCallback<Void>() {
					public void onFailure(Throwable caught) {
					}
					
					public void onSuccess(Void result) {								
					}
				}); 
			}
		});

		toolkitUserListBox.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				toolkitUserNameTextBox.setText(toolkitUserListBox.getItemText(toolkitUserListBox.getSelectedIndex()));
				managerRemoteService.getUserPassword(toolkitUserListBox.getItemText(toolkitUserListBox.getSelectedIndex()), new AsyncCallback<String>() {
					public void onFailure(Throwable caught) {
					}
						
					public void onSuccess(String result) {
						toolkitPasswordTextBox1.setText(result);
						toolkitPasswordTextBox2.setText(result);
					}
				}); 
			}
		});

		toolkitUserRegistrySetAndSaveButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				managerRemoteService.saveUserRegistry(toolkitUserNameTextBox.getText(), toolkitPasswordTextBox1.getText(), new AsyncCallback<String[]>() {
					public void onFailure(Throwable caught) {
					}
						
					public void onSuccess(String[] result) {
						for (int i = 0; i < result.length; i++) toolkitUserListBox.addItem(result[i]);
						toolkitPasswordTextBox1.setText("");
						toolkitPasswordTextBox2.setText("");
					}
				}); 
			}
		});

		toolkitUserRegistryRemoveAndSaveButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				managerRemoteService.removeRegistryEntry(toolkitUserNameTextBox.getText(), new AsyncCallback<String[]>() {
					public void onFailure(Throwable caught) {
					}
						
					public void onSuccess(String[] result) {
						for (int i = 0; i < result.length; i++) toolkitUserListBox.addItem(result[i]);
						toolkitPasswordTextBox1.setText("");
						toolkitPasswordTextBox2.setText("");
					}
				}); 
			}
		});

		toolkitInitializationFileTypesListBox.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				managerRemoteService.getInitFileName(toolkitInitializationFileTypesListBox.getItemText(toolkitInitializationFileTypesListBox.getSelectedIndex()), new AsyncCallback<String>() {
					public void onFailure(Throwable caught) {
					}
						
					public void onSuccess(String result) {
						toolkitInitializationFileNameTextBox.setText(result);
					}
				}); 
			}
		});

		toolkitInitializationFilesSetAndSaveButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				managerRemoteService.saveToolkitInitFile(toolkitInitializationFileNameTextBox.getText(), toolkitInitializationFileTypesListBox.getItemText(toolkitInitializationFileTypesListBox.getSelectedIndex()), new AsyncCallback<Void>() {
					public void onFailure(Throwable caught) {
					}
						
					public void onSuccess(Void result) {
					}
				}); 
			}
		});

		servletDiagnosticsServletListBox.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				managerRemoteService.getServletDiagnosticsPage(servletDiagnosticsServletListBox.getItemText(servletDiagnosticsServletListBox.getSelectedIndex()), getSessionId(), Window.Location.getHost(), new AsyncCallback<String>() {
					public void onFailure(Throwable caught) {
					}
						
					public void onSuccess(String url) {
						servletDiagnosticsPageFrame.setUrl(url);
					}
				}); 
			}
		});

		performanceJavaGcSetButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {		
				managerRemoteService.setJavaGarbageCollection(performanceJavaGcListBox.getItemText(performanceJavaGcListBox.getSelectedIndex()), new AsyncCallback<Void>() {
					public void onFailure(Throwable caught) {
					}

					public void onSuccess(Void result) {
						managerRemoteService.getJavaGarbageCollection(new AsyncCallback<String>() {
							public void onFailure(Throwable caught) {
							}

							public void onSuccess(String result) {
								if (parseReturnString(result).equals("on")) performanceJavaGcListBox.setSelectedIndex(0);
								if (parseReturnString(result).equals("off")) performanceJavaGcListBox.setSelectedIndex(1);
							}
						}); 
					}
				}); 
			}
		});

		performanceWeb2cGcSetButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {	
				managerRemoteService.setWeb2cToolkitGarbageCollection(performanceWeb2cGcListBox.getItemText(performanceWeb2cGcListBox.getSelectedIndex()), new AsyncCallback<Void>() {
					public void onFailure(Throwable caught) {
					}

					public void onSuccess(Void result) {
						managerRemoteService.getWeb2cToolkitGarbageCollection(new AsyncCallback<String>() {
							public void onFailure(Throwable caught) {
							}

							public void onSuccess(String result) {
								if (parseReturnString(result).equals("on")) performanceWeb2cGcListBox.setSelectedIndex(0);
								if (parseReturnString(result).equals("off")) performanceWeb2cGcListBox.setSelectedIndex(1);
							}
						}); 
					}
				}); 
			}
		});

		performanceDoJavaGcButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				managerRemoteService.doJavaGarbageCollection(new AsyncCallback<Void>() {
					public void onFailure(Throwable caught) {
					}

					public void onSuccess(Void result) {
					}
				}); 
			}
		});

		debugWebCommunicationListBox.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				managerRemoteService.setWebCommunicationDebugFlag(debugWebCommunicationListBox.getItemText(debugWebCommunicationListBox.getSelectedIndex()), new AsyncCallback<Void>() {
					public void onFailure(Throwable caught) {
					}
						
					public void onSuccess(Void result) {
					}
				}); 
			}
		});

		debugControlSystemCommunicationListBox.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				managerRemoteService.setControlSystemCommunicationDebugFlag(debugControlSystemCommunicationListBox.getItemText(debugControlSystemCommunicationListBox.getSelectedIndex()), new AsyncCallback<Void>() {
					public void onFailure(Throwable caught) {
					}
						
					public void onSuccess(Void result) {
					}
				}); 
			}
		});

		debugGetLogFileButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				managerRemoteService.getLogFile(debugLogFilesListBox.getItemText(debugLogFilesListBox.getSelectedIndex()), debugNumberOfLinesListBox.getItemText(debugNumberOfLinesListBox.getSelectedIndex()), new AsyncCallback<String[]>() {
					public void onFailure(Throwable caught) {
					}
						
					public void onSuccess(String[] result) {
						String text = "";
						for (int i = 0; i < result.length; i++) text = text + result[i] + "\n";
						debugLogFileTextArea.setText(text);
					}
				}); 
			}
		});

		debugClearButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				managerRemoteService.clearLogFile(debugLogFilesListBox.getItemText(debugLogFilesListBox.getSelectedIndex()), new AsyncCallback<Void>() {
					public void onFailure(Throwable caught) {
					}
						
					public void onSuccess(Void result) {
						debugLogFileTextArea.setText("");
					}
				}); 
			}
		});
		
		twitterInitParamsSetButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				if (twitterPasswordTextBox1.getText().equals(twitterPasswordTextBox2.getText())) {
					managerRemoteService.setTwitterId(twitterIdTextBox.getText(), new AsyncCallback<Void>() {
						public void onFailure(Throwable caught) {
						}
					
						public void onSuccess(Void result) {								
						}
					}); 
					managerRemoteService.setTwitterPassword(twitterPasswordTextBox1.getText(), new AsyncCallback<Void>() {
						public void onFailure(Throwable caught) {
						}
					
						public void onSuccess(Void result) {								
						}
					}); 
					managerRemoteService.setTwitterLoggingOption(twitterLoggingListBox.getItemText(twitterLoggingListBox.getSelectedIndex()), new AsyncCallback<Void>() {
						public void onFailure(Throwable caught) {
						}
					
						public void onSuccess(Void result) {								
						}
					}); 
				}
				else {
					Window.alert("Password string and confirmation string must coincide!");
				}
			}
		});

		twitterInitFileSaveButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				if (twitterPasswordTextBox1.getText().equals(twitterPasswordTextBox2.getText())) {
					managerRemoteService.saveTwitterId(twitterIdTextBox.getText(), new AsyncCallback<Void>() {
						public void onFailure(Throwable caught) {
						}
					
						public void onSuccess(Void result) {								
						}
					}); 
					managerRemoteService.saveTwitterPassword(twitterPasswordTextBox1.getText(), new AsyncCallback<Void>() {
						public void onFailure(Throwable caught) {
						}
					
						public void onSuccess(Void result) {								
						}
					});
					managerRemoteService.saveTwitterLoggingOption(twitterLoggingListBox.getItemText(twitterLoggingListBox.getSelectedIndex()), new AsyncCallback<Void>() {
						public void onFailure(Throwable caught) {
						}
					
						public void onSuccess(Void result) {								
						}
					}); 
				}
				else {
					Window.alert("Password string and confirmation string must coincide!");
				}
			}
		});

		twitterServiceRequestPermitButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				managerRemoteService.doRequestTwitterPermit(new AsyncCallback<String>() {
					public void onFailure(Throwable caught) {
					}
				
					public void onSuccess(String result) {	
						twitterControlTextBox.setText(result);
						Window.open(result, "Twitter", "");
					}
				}); 
			}
		});

		twitterStartServiceButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				managerRemoteService.doStartPublishingTwitterStatus(new AsyncCallback<String>() {
					public void onFailure(Throwable caught) {
					}
				
					public void onSuccess(String result) {	
						twitterControlTextBox.setText(result);
					}
				}); 
			}
		});

		twitterStopServiceButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				managerRemoteService.doStopPublishingTwitterStatus(new AsyncCallback<String>() {
					public void onFailure(Throwable caught) {
					}
				
					public void onSuccess(String result) {	
						twitterControlTextBox.setText(result);
					}
				}); 
			}
		});

		twitterServiceStatusUpdateButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				managerRemoteService.getTwitterServiceStatus(new AsyncCallback<Boolean>() {
					public void onFailure(Throwable caught) {
					}

					public void onSuccess(Boolean result) {
						if (result == true) twitterServiceAvailableTextBox.setText("yes");
						else twitterServiceAvailableTextBox.setText("no");
					}
				}); 

				managerRemoteService.getTwitterPublishingStatus(new AsyncCallback<Boolean>() {
					public void onFailure(Throwable caught) {
					}

					public void onSuccess(Boolean result) {
						if (result == true) twitterServicePublishingStartedTextBox.setText("yes");
						else twitterServicePublishingStartedTextBox.setText("no");
					}
				}); 

				managerRemoteService.getMostRecentTwitterStatus(new AsyncCallback<String>() {
					public void onFailure(Throwable caught) {
					}

					public void onSuccess(String result) {
						twitterServiceMostRecentStatusTextBox.setText(result);
					}
				}); 
			}
		});

		twitterArmServiceButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				managerRemoteService.doArmTwitterService(new AsyncCallback<Void>() {
					public void onFailure(Throwable caught) {
					}
				
					public void onSuccess(Void result) {
					}
				}); 
			}
		});

		twitterDisarmServiceButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				managerRemoteService.doDisarmTwitterService(new AsyncCallback<Void>() {
					public void onFailure(Throwable caught) {
					}
				
					public void onSuccess(Void result) {
					}
				}); 
			}
		});

		smtpInitParamsSetButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				if (smtpPasswordTextBox1.getText().equals(smtpPasswordTextBox2.getText())) {
					managerRemoteService.setSMTPId(smtpIdTextBox.getText(), new AsyncCallback<Void>() {
						public void onFailure(Throwable caught) {
						}
					
						public void onSuccess(Void result) {								
						}
					}); 
					managerRemoteService.setSMTPPassword(smtpPasswordTextBox1.getText(), new AsyncCallback<Void>() {
						public void onFailure(Throwable caught) {
						}
					
						public void onSuccess(Void result) {								
						}
					}); 
					managerRemoteService.setSMTPHost(smtpHostTextBox.getText(), new AsyncCallback<Void>() {
						public void onFailure(Throwable caught) {
						}
					
						public void onSuccess(Void result) {								
						}
					}); 
					managerRemoteService.setSMTPLoggingOption(smtpLoggingListBox.getItemText(smtpLoggingListBox.getSelectedIndex()), new AsyncCallback<Void>() {
						public void onFailure(Throwable caught) {
						}
					
						public void onSuccess(Void result) {								
						}
					}); 
				}
				else {
					Window.alert("Password string and confirmation string must coincide!");
				}
			}
		});

		smtpInitFileSaveButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				if (smtpPasswordTextBox1.getText().equals(smtpPasswordTextBox2.getText())) {
					managerRemoteService.saveSMTPId(smtpIdTextBox.getText(), new AsyncCallback<Void>() {
						public void onFailure(Throwable caught) {
						}
					
						public void onSuccess(Void result) {								
						}
					}); 
					managerRemoteService.saveSMTPPassword(smtpPasswordTextBox1.getText(), new AsyncCallback<Void>() {
						public void onFailure(Throwable caught) {
						}
					
						public void onSuccess(Void result) {								
						}
					});
					managerRemoteService.saveSMTPHost(smtpHostTextBox.getText(), new AsyncCallback<Void>() {
						public void onFailure(Throwable caught) {
						}
					
						public void onSuccess(Void result) {								
						}
					});
					managerRemoteService.saveSMTPLoggingOption(smtpLoggingListBox.getItemText(smtpLoggingListBox.getSelectedIndex()), new AsyncCallback<Void>() {
						public void onFailure(Throwable caught) {
						}
					
						public void onSuccess(Void result) {								
						}
					}); 
				}
				else {
					Window.alert("Password string and confirmation string must coincide!");
				}
			}
		});

		smtpServiceStatusUpdateButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				managerRemoteService.getSMTPServiceStatus(new AsyncCallback<Boolean>() {
					public void onFailure(Throwable caught) {
					}

					public void onSuccess(Boolean result) {
						if (result == true) smtpServiceAvailableTextBox.setText("yes");
						else smtpServiceAvailableTextBox.setText("no");
					}
				}); 
				managerRemoteService.getSMTPMessageSendingStatus(new AsyncCallback<String>() {
					public void onFailure(Throwable caught) {
					}

					public void onSuccess(String result) {
						smtpStatusTextBox.setText(result);
					}
				}); 
			}
		});

		smtpArmServiceButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				managerRemoteService.doArmSMTPService(new AsyncCallback<Void>() {
					public void onFailure(Throwable caught) {
					}
				
					public void onSuccess(Void result) {
					}
				}); 
			}
		});

		smtpDisarmServiceButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				managerRemoteService.doDisarmSMTPService(new AsyncCallback<Void>() {
					public void onFailure(Throwable caught) {
					}
				
					public void onSuccess(Void result) {
					}
				}); 
			}
		});
		
		updateTimer = new Timer() {
			public void run() {		
				managerRemoteService.getPercentagedHeapSpaceUsage(getSessionId(), new AsyncCallback<String>() {
					public void onFailure(Throwable caught) {
					}

					public void onSuccess(String result) {
						performanceHeapSpaceValueLabel.setText(parseReturnString(result));
					}
				}); 			
				managerRemoteService.getPercentagedCPUUsage(getSessionId(), new AsyncCallback<String>() {
					public void onFailure(Throwable caught) {
					}

					public void onSuccess(String result) {
						performanceCpuUsageValueLabel.setText(parseReturnString(result));
					}
				}); 			
				managerRemoteService.getLoadedClassCount(getSessionId(), new AsyncCallback<String>() {
					public void onFailure(Throwable caught) {
					}

					public void onSuccess(String result) {
						performanceTotalClassCountValueLabel.setText(parseReturnString(result));
					}
				}); 				
			}
		};
		updateTimer.scheduleRepeating(2000);
	}

	/**
	 * Parses the return string
	 * @param returnString
	 * @return parsed string
	 */
	public String parseReturnString(String returnString) {
		
		return returnString.replace("<return>", "").replace("</return>", "");		
	}

	/**
	 * Returns the Web2c session id attached to this page stored in the hidden HTML field "sessionId".
	 * @return session id
	 */
	public native String getSessionId() /*-{
		return $doc.getElementById("sessionId").value;
	}-*/;
}
