package de.desy.web2cToolkit.web2cUtil.web2cDebug;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * @author R.Bacher, DESY
 */
public class Web2cKeyBoardListener {
	
	private boolean debugWebCommunication = false;
	private boolean debugControlSystemCommunication = false;
	private boolean debugConfigurationFileParsing = false;

	/**
	 * KeyBoardListener
	 */
	public Web2cKeyBoardListener() {
	}
	
	/**
	 * Returns web communication debug flag
	 * @return web communication debug flag
	 */
	public boolean getDebugWebCommunication() {

		return debugWebCommunication;
	}
	
	/**
	 * Sets the web communication debug flag
	 * @param flag web communication debug flag
	 */
	public void setDebugWebCommunication(boolean flag) {
		
		debugWebCommunication = flag;
	}
	
	/**
	 * Returns control system communication debug flag
	 * @return control system communication debug flag
	 */
	public boolean getDebugControlSystemCommunication() {

		return debugControlSystemCommunication;
	}
	
	/**
	 * Sets the control system communication debug flag
	 * @param flag control system communication debug flag
	 */
	public void setDebugControlSystemCommunication(boolean flag) {
		
		debugControlSystemCommunication = flag;
	}
	
	/**
	 * Returns configuration file parsing debug flag
	 * @return configuration file parsing debug flag
	 */
	public boolean getDebugConfigurationFileParsing() {

		return debugConfigurationFileParsing;
	}
	
	/**
	 * Sets the configuration file parsing debug flag
	 * @param flag configuration file parsing debug flag
	 */
	public void setDebugConfigurationFileParsing(boolean flag) {
		
		debugConfigurationFileParsing = flag;
	}
	
	/**
	 * Reads the keyboard input
	 */
	public void getKeyboardInput() {
		
		try {
			BufferedReader keyBoard = new BufferedReader(new InputStreamReader(System.in));
			if (keyBoard.ready()) {
				String keyBoardInput = keyBoard.readLine();
				if (keyBoardInput.equals("debugWebCommunicationOn")) {
					debugWebCommunication = true;
				}		
				if (keyBoardInput.equals("debugWebCommunicationOff")) {
					debugWebCommunication = false;
				}
				
				if (keyBoardInput.equals("debugControlSystemCommunicationOn")) {
					debugControlSystemCommunication = true;
				}	
				if (keyBoardInput.equals("debugControlSystemCommunicationOff")) {
					debugControlSystemCommunication = false;
				}
				
				if (keyBoardInput.equals("debugConfigurationFileParsingOn")) { 
					debugConfigurationFileParsing = true;
				}	
				if (keyBoardInput.equals("debugConfigurationFileParsingOff")) {
					debugConfigurationFileParsing = false;
				}
			}
			keyBoard.close();
		} 
		catch (IOException e) {
			e.printStackTrace();
		}
	}
}
