package de.desy.web2cToolkit.web2cUtil.web2cEscape;

public class Web2cASCIICharacterEscaper {
	
	/**
	 * Web2cASCIICharacterEscaper: ASCII character encoder / decoder
	 */
	public Web2cASCIICharacterEscaper() {

		super();
	}  
	
	/**
	 * Encodes a string (to hexadecimal representation %XX)
	 * @param value string to encode
	 * @return encoded string
	 */
	public String encodeString(String value) {
		
		StringBuffer toHexaDecimalString = new StringBuffer();
		
		char[] chars = value.toCharArray();
	    for(int i = 0; i < chars.length; i++) {
	    	if ((int)chars[i] <= 0x1f && (int)chars[i] != 0x0a) toHexaDecimalString.append("%20");
	    	else {
	    		toHexaDecimalString.append("%"); 
	    		toHexaDecimalString.append(Integer.toHexString((int)chars[i]));
	    	}
	    }
	    
	    return toHexaDecimalString.toString();		
	}
	
	/**
	 * Decodes a string (from hexadecimal representation %XX)
	 * @param value string to decode
	 * @return decoded string
	 */
	public String decodeString(String value) {
		
		StringBuffer fromHexaDecimalString = new StringBuffer();
		
		String[] codePoint = value.split("%");
	    for(int i = 1; i < codePoint.length; i++) {
	    	if (!codePoint[i].contains(",")) fromHexaDecimalString.append(String.valueOf(Character.toChars(Integer.valueOf(codePoint[i], 16))));
	    	else fromHexaDecimalString.append(String.valueOf(Character.toChars(Integer.valueOf(codePoint[i].substring(0, codePoint[i].length() - 1), 16))) + ",");
	    }
	    
	    return fromHexaDecimalString.toString();		
	}

}
