/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components;

import com.cosylab.gui.components.util.PopupManageable;

import java.util.Map;


/**
 * <code>SimpleDisplayer</code> interface defines some usefull features, that
 * should have all GUI widget, that wants to colaborate with Abeans framework.
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 * @version $id$
 */
public interface SimpleDisplayer extends PopupManageable
{
	/**
	 * Returns map of editors for different displayer contexts.  Keys ar of
	 * form "slider", "slider/alarms", etc. Value is  <code>Class</code> of
	 * editor, which customizes displayer in aspect of  context key. Values
	 * must implement <code>Editor</code> interace.
	 *
	 * @return map of editors
	 */
	Map<String, Class> getEditors();
}

/* __oOo__ */
