/*
 * Copyright (c) 2006 Stiftung Deutsches Elektronen-Synchroton,
 * Member of the Helmholtz Association, (DESY), HAMBURG, GERMANY.
 *
 * THIS SOFTWARE IS PROVIDED UNDER THIS LICENSE ON AN "../AS IS" BASIS.
 * WITHOUT WARRANTY OF ANY KIND, EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR PARTICULAR PURPOSE AND
 * NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE. SHOULD THE SOFTWARE PROVE DEFECTIVE
 * IN ANY RESPECT, THE USER ASSUMES THE COST OF ANY NECESSARY SERVICING, REPAIR OR
 * CORRECTION. THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF THIS LICENSE.
 * NO USE OF ANY SOFTWARE IS AUTHORIZED HEREUNDER EXCEPT UNDER THIS DISCLAIMER.
 * DESY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS,
 * OR MODIFICATIONS.
 * THE FULL LICENSE SPECIFYING FOR THE SOFTWARE THE REDISTRIBUTION, MODIFICATION,
 * USAGE AND OTHER RIGHTS AND OBLIGATIONS IS INCLUDED WITH THE DISTRIBUTION OF THIS
 * PROJECT IN THE FILE LICENSE.HTML. IF THE LICENSE IS NOT INCLUDED YOU MAY FIND A COPY
 * AT HTTP://WWW.DESY.DE/LEGAL/LICENSE.HTM
 */

package de.desy.acop.chart.customizer;

import java.awt.GridBagLayout;
import java.beans.Customizer;
import java.beans.PropertyChangeSupport;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.JTextField;

import de.desy.acop.chart.Acop;

/**
 * @author wu To change the template for this generated type comment go to
 *         Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class AcopCustomizer extends JTabbedPane implements Customizer
{
//  private String accessRate, accessRateOld;
//  private AccessMode accessMode;
  // private int accessModeIndex, accessModeIndexOld;
  // private AccessMode[] accessModeString = AccessMode.values();
  protected Acop bean; // The bean being customized.
  private ColorCustomizerPanel colorCustomizer;
  private DisplayCustomizerPanel displayCustomizer;
  private FrameCustomizerPanel frameCustomizer;
  private GraphCustomizerPanel graphCustomizer;
  private AxisCustomizerPanel axisCustomizer;
  private SpecialCustomizerPanel specialCustomizer;
  private MarkersCustomizerPanel markersCustomizer;
  /**
   * This is the default constructor
   */
  public AcopCustomizer()
  {
    super();
//    System.err.println("TEST1");
    initialize();
  }
  /**
   * This method initializes this
   * 
   * @return void
   */
  private void initialize()
  {
    listeners = new PropertyChangeSupport(this);
//    System.out.println("TEST1");
    // this.setLayout(new CardLayout() );
    setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
    
    JPanel p = new JPanel();
    p.setLayout(new GridBagLayout());
    
//    p.add(getDevice(), new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0, GridBagConstraints.CENTER,
//        GridBagConstraints.NONE, new Insets(4, 4, 4, 4), 0, 0));
//    p.add(getDisplayButton(), new GridBagConstraints(1, 0, 1, 1, 1.0, 1.0, GridBagConstraints.CENTER,
//        GridBagConstraints.NONE, new Insets(4, 4, 4, 4), 0, 0));
//    p.add(getLabel(), new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0, GridBagConstraints.EAST,
//        GridBagConstraints.NONE, new Insets(4, 4, 4, 4), 0, 0));
//    p.add(getChoiceMode(), new GridBagConstraints(1, 1, 1, 1, 1.0, 1.0, GridBagConstraints.CENTER,
//        GridBagConstraints.HORIZONTAL, new Insets(4, 4, 4, 4), 0, 0));
//    p.add(getLabel1(), new GridBagConstraints(0, 2, 1, 1, 1.0, 1.0, GridBagConstraints.EAST,
//        GridBagConstraints.NONE, new Insets(4, 4, 4, 4), 0, 0));
//    p.add(getTextFieldRate(), new GridBagConstraints(1, 2, 1, 1, 1.0, 1.0, GridBagConstraints.CENTER,
//        GridBagConstraints.HORIZONTAL, new Insets(4, 4, 4, 4), 0, 0));
//    addTab("Device", p);
    
    displayCustomizer = new DisplayCustomizerPanel();
    addTab("Display", displayCustomizer);
    
    frameCustomizer = new FrameCustomizerPanel();
    addTab("Frame", frameCustomizer);

    graphCustomizer = new GraphCustomizerPanel();
    addTab("Graph", graphCustomizer);
    
    axisCustomizer = new AxisCustomizerPanel();
    addTab("Axis", axisCustomizer);

    specialCustomizer = new SpecialCustomizerPanel();
    addTab("Special", specialCustomizer);

    markersCustomizer = new MarkersCustomizerPanel();
    addTab("Markers", markersCustomizer);
/*
    p = new JPanel();
    p.setLayout(new GridBagLayout());
    p.add(new JButton("Test"), new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0, GridBagConstraints.CENTER,
        GridBagConstraints.NONE, new Insets(4, 4, 4, 4), 0, 0));
    addTab("Marker", p);
*/    
    colorCustomizer = new ColorCustomizerPanel();
    addTab("Colors", colorCustomizer);
    
    this.setSize(478, 297);
  }
  public void setObject(Object o)
  {
    bean = (Acop) o; // Save the object we're customizing.
    // Put a label at the top of the panel.
    // this.setLayout(new BorderLayout());
//    accessRate = "555";
    // accessRate = new String(bean.getAcopTransport().getAccessRate());
//    accessRateOld = new String(accessRate);
//    textFieldRate.setText(accessRate);
//    accessMode = AccessMode.WRITE;
    // accessMode = bean.getAcopTransport().getAccessMode();

//    choiceMode.setSelectedItem(accessMode);
    displayCustomizer.setAcopBean(bean);
    frameCustomizer.setAcopBean(bean);
    graphCustomizer.setAcopBean(bean);
    axisCustomizer.setAcopBean(bean);
    specialCustomizer.setAcopBean(bean);
    markersCustomizer.setAcopBean(bean);
    colorCustomizer.setAcopBean(bean);
  }
  /*
   * public void addPropertyChangeListener(PropertyChangeListener l) { // defer
   * to the support object listeners.addPropertyChangeListener(l); } public void
   * removePropertyChangeListener(PropertyChangeListener l) { // defer to the
   * support object listeners.removePropertyChangeListener(l); }
   */
  // This code uses the PropertyChangeSupport class to maintain a list of
  // listeners interested in the edits we make to the bean.
  protected PropertyChangeSupport listeners;
//  private JButton device = null;
  private JLabel label = null;
  private JButton DisplayButton = null;
  private JComboBox choiceMode = null;
  private JLabel label1 = null;
  private JTextField textFieldRate = null;
  /**
   * This method initializes device
   * 
   * @return java.awt.Button
   */
//  private JButton getDevice()
//  {
//    if (device == null)
//    {
//      device = new JButton();
//      // device.setBounds(20, 27, 55, 23);
//      device.setText("Device");
//      device.setName("Device");
//    }
//    return device;
//  }
  /**
   * This method initializes label
   * 
   * @return java.awt.Label
   */
  private JLabel getLabel()
  {
    if (label == null)
    {
      label = new JLabel();
      // label.setBounds(23, 86, 38, 23);
      label.setText("Mode:");
      label.setName("Mode");
    }
    return label;
  }
  /**
   * This method initializes DisplayButton
   * 
   * @return java.awt.Button
   */
  private JButton getDisplayButton()
  {
    if (DisplayButton == null)
    {
      DisplayButton = new JButton();
      // DisplayButton.setBounds(82, 25, 54, 23);
      DisplayButton.setText("Display");
      DisplayButton.setName("Display");
    }
    return DisplayButton;
  }
  /**
   * This method initializes choiceMode
   * 
   * @return java.awt.Choice
   */
//  private JComboBox getChoiceMode()
//  {
//    if (choiceMode == null)
//    {
//      choiceMode = new JComboBox(AccessMode.values());
//      // choiceMode.setBounds(76, 87, 78, 38);
//      choiceMode.addItemListener(new java.awt.event.ItemListener()
//      {
//        public void itemStateChanged(java.awt.event.ItemEvent e)
//        {
//          if (accessMode != choiceMode.getSelectedItem())
//          {
//            accessMode = (AccessMode) choiceMode.getSelectedItem();
//            // bean.getAcopTransport().setAccessMode(accessMode);
//            System.out.println("setAccessMode"); // TODO Auto-generated Event
//                                                  // stub itemStateChanged()
//            firePropertyChange(null, null, null);
//          }
//          System.out.println("itemStateChanged()"); // TODO Auto-generated Event
//                                                    // stub itemStateChanged()
//        }
//      });
//      // for (int i=0; i<accessModeString.length; i++) choiceMode.setName(
//      // accessModeString[i] );
//    }
//    return choiceMode;
//  }
  /**
   * This method initializes label1
   * 
   * @return java.awt.Label
   */
  private JLabel getLabel1()
  {
    if (label1 == null)
    {
      label1 = new JLabel();
      // label1.setBounds(22, 60, 34, 22);
      label1.setText("Rate:");
      label1.setName("Rate");
    }
    return label1;
  }
  /**
   * This method initializes textFieldRate
   * 
   * @return java.awt.TextField
   */
//  private JTextField getTextFieldRate()
//  {
//    if (textFieldRate == null)
//    {
//      textFieldRate = new JTextField();
//      // textFieldRate.setBounds(77, 61, 70, 19);
//      textFieldRate.setName("RateText");
//      System.out.println("       textFieldRate.setName  (RateText) "); // TODO
//                                                                        // Auto-generated
//                                                                        // Event
//                                                                        // stub
//                                                                        // textValueChanged()
//      textFieldRate.addPropertyChangeListener(new PropertyChangeListener()
//      {
//        public void propertyChange(PropertyChangeEvent evt)
//        {
//          accessRate = textFieldRate.getText();
//          System.out.println("   textValueChanged(): " + accessRate); // TODO
//                                                                      // Auto-generated
//                                                                      // Event
//                                                                      // stub
//                                                                      // textValueChanged()
//          if (accessRateOld != accessRate && bean != null)
//          {
//            // bean.getAcopTransport().setAccessRate(accessRate);
//            accessRateOld = accessRate;
//            System.out.println("try  setAccessRate"); // TODO Auto-generated
//                                                      // Event stub
//                                                      // itemStateChanged()
//            firePropertyChange(null, null, null);
//          }
//        }
//      });
//    }
//    return textFieldRate;
//  }
  public static void main(String[] args)
  {
    try
    {
      JFrame f = new JFrame();
      AcopCustomizer c = new AcopCustomizer();
      f.setContentPane(c);
      Acop a = new Acop();
      c.setObject(a);
      f.setVisible(true);
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
} // @jve:decl-index=0:visual-constraint="7,1"
