package de.desy.acop.video.displayer;

/**
 * To resize an image in the ImageDisplayer pane
 * 
 * @author mdavid
 * 
 */
public enum ImageZoom {
	/**
	 * The image automatically resizes to fit the dimensions of the ImageDisplayer
	 */
	AUTO("Auto"),

	/**
	 * Zoom at 50%
	 */
	HALF("50%"),

	/**
	 * Zoom at 100%
	 */
	NORMAL("100%"),

	/**
	 * Zoom at 200%
	 */
	DOUBLE("200%");

	private String descr;

	/**
	 * Sets a description of the zoom mode
	 * 
	 * @param description
	 */
	private ImageZoom(String description) {
		descr = description;
	}

	/**
	 * @return Description of the zoom mode
	 */
	public String getDescription() {
		return descr;
	}
}
