package de.desy.acop.video.timageio.test;

import java.awt.image.BufferedImage;
import java.awt.image.DataBufferByte;
import java.io.File;
import java.io.IOException;
import java.util.Arrays;

import javax.imageio.ImageIO;

import de.desy.acop.video.displayer.timage.TImageUtils;
import de.desy.acop.video.timageio.TBufferedImage;
import de.desy.acop.video.timageio.TImageIO;
import de.desy.tine.types.IMAGE;

public class TestMe {
	public static void main(String[] args) {
		TestMe app = new TestMe();
		try {
			app.testSave();

		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
		System.exit(0);
	}

	void run() throws IOException {
		TBufferedImage tbiOrg = TImageIO.read(new File("C:\\test\\background-image.png"));
		BufferedImage biOrg = tbiOrg.getBufferedImage();
		IMAGE tiOrg = TBufferedImage.toIMAGE(biOrg);

		TImageIO.write(tbiOrg, new File("C:\\test\\background-image-saved.png"));
		// TImageIO.write(new TBufferedImage(ti), new
		// File("C:\\test\\background-image-saved.png"));

		TBufferedImage tbiNew = TImageIO.read(new File("C:\\test\\background-image-saved.png"));
		BufferedImage biNew = tbiNew.getBufferedImage();
		IMAGE tiNew = TBufferedImage.toIMAGE(biNew);

		System.out.println("TImageUtils.compare(tiOrg, tiNew): " + TImageUtils.compare(tiOrg, tiNew));

		// ******************************************

		TImageIO.write(new TBufferedImage(tiOrg), new File("C:\\test\\background-image-resaved.png"));

		TBufferedImage tbiRenew = TImageIO.read(new File("C:\\test\\background-image-resaved.png"));
		BufferedImage biRenew = tbiRenew.getBufferedImage();
		IMAGE tiRenew = TBufferedImage.toIMAGE(biRenew);

		System.out.println("TImageUtils.compare(tiOrg, tiRenew): " + TImageUtils.compare(tiOrg, tiRenew));
	}

	void testCompare() throws IOException {
		TBufferedImage tbiOrg = TImageIO.read(new File("C:\\test\\background-image.png"));
		TBufferedImage tbiNew = TImageIO.read(new File("C:\\test\\background-image-saved.png"));

		BufferedImage biOrg = tbiOrg.getBufferedImage();
		BufferedImage biNew = tbiNew.getBufferedImage();

		System.out.println("Data arrays equals (biOrg, biNew): " + Arrays.equals( //
				((DataBufferByte) biOrg.getRaster().getDataBuffer()).getData(), //
				((DataBufferByte) biNew.getRaster().getDataBuffer()).getData()));

		IMAGE tiOrg = TBufferedImage.toIMAGE(biOrg, false);
		IMAGE tiNew = TBufferedImage.toIMAGE(biNew, false);
		System.out.println("TImageUtils.compare(tiOrg, tiNew): " + TImageUtils.compare(tiOrg, tiNew));
	}

	void testSave() throws IOException {
		TBufferedImage tbiOrg = TImageIO.read(new File("C:\\test\\background-image.png"));
		BufferedImage biOrg = tbiOrg.getBufferedImage();
		IMAGE tiOrg = TBufferedImage.toIMAGE(biOrg, false);

		TBufferedImage tbi = new TBufferedImage(tiOrg);
		TImageIO.write(tbi, new File("C:\\test\\background-image-save11.png"));

		TBufferedImage tbiNew = TImageIO.read(new File("C:\\test\\background-image-save11.png"));
		BufferedImage biNew = tbiNew.getBufferedImage();
		IMAGE tiNew = TBufferedImage.toIMAGE(biNew, false);

		System.out.println("Data arrays equals (biOrg, biNew): " + Arrays.equals( //
				((DataBufferByte) biOrg.getRaster().getDataBuffer()).getData(), //
				((DataBufferByte) biNew.getRaster().getDataBuffer()).getData()));

		System.out.println("TImageUtils.compare(tiOrg, tiNew): " + TImageUtils.compare(tiOrg, tiNew));
	}

	void testToImage() throws IOException {
		File file = new File("C:\\test\\background-image.png");

		BufferedImage biOrg = ImageIO.read(file);
		IMAGE tiOrg = TBufferedImage.toIMAGE(biOrg);

		TBufferedImage tbiNew = TImageIO.read(file);
		BufferedImage biNew = tbiNew.getBufferedImage();
		IMAGE tiNew = TBufferedImage.toIMAGE(biNew);

		System.out.println("Data arrays equals (biOrg, biNew): " + Arrays.equals( //
				((DataBufferByte) biOrg.getRaster().getDataBuffer()).getData(), //
				((DataBufferByte) biNew.getRaster().getDataBuffer()).getData()));

		System.out.println("TImageUtils.compare(tiOrg, tiNew): " + TImageUtils.compare(tiOrg, tiNew));
	}
}
