/*
 * Created on Jul 12, 2006
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package de.desy.tine.client;

import de.desy.tine.dataUtils.TDataType;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.definitions.TFormat;
import de.desy.tine.definitions.TMode;
import de.desy.tine.queryUtils.TQuery;

public class TWildcardSingleCallback implements TLinkCallback
{
  public void callback(TLink link)
  {
    TWildcardLink wc = link.twcl;
    String srv, dev;
    int fmt = TFormat.CF_NULL, mode, i, n, cc = 0;

    switch (link.getLinkStatus())
    {
      case TErrorList.illegal_property:
        /* will be returned by the group server */
      case TErrorList.data_not_local:
        /* mark this entry as CM_REGISTER */
        mode = link.sub.mode;
        link.sub.mode = TMode.CM_REGISTER;
        //c->heartbeat = 0;
        /* get the device list and length and allocate the relevant arrays */
        wc.list = TQuery.getDeviceNames(link.cntName,link.expName,null);
        if (wc.list == null) 
        {
          cc = TErrorList.connection_timeout;
          break;
        }
        /* now allocate the device tables */
        n = wc.list.length;
        wc.length = n;
        wc.status = new int[n];
        wc.links = new TLink[n];
        /* n is the total number, so this is a worst case allocation ... */
        switch (wc.format)
        {
          case TFormat.CF_USTRING:
          case TFormat.CF_NAME16DBLDBL:
          case TFormat.CF_NAME32DBLDBL:
          case TFormat.CF_NAME64DBLDBL:
          case TFormat.CF_NAME16FI:
            fmt = TFormat.CF_FLOAT;
            break;
          case TFormat.CF_NAME16II:
            fmt = TFormat.CF_LONG;
            break;
          default:
            if (wc.format > TFormat.CF_NAME32 && link.devName.compareTo("*") != 0) 
            {
              cc = TErrorList.illegal_format;
              break;
            }
            fmt = wc.format;
            // data reference ????
            break;
        }
        /* if the wildcard contains characters, then n returned here is likely to be smaller than above */
        wc.numPending = wc.length;
        
        TDataType din = link.getInputDataObject();
        srv = link.cntName.length() > 0 ? "/" + link.cntName + "/" : "";
        srv += link.expName;
        for (i=0; i<wc.length; i++)
        { /* start the individual links (these will be redirected by the source) */
          TDataType dout = new TDataType(1,(short)fmt);
          dev = srv + "/" + wc.list[i];
          wc.links[i] = new TLink(dev,link.devProperty,dout,din,link.devAccess);
          wc.links[i].callbackId = i;
          wc.links[i].twcl = wc; // pass it on
          wc.links[i].linkStatus = wc.status[i] = TErrorList.not_ready;
          wc.links[i].delayEstablishLink = true;
          wc.links[i].attach(mode,wc.gcb,link.sub.pollingInterval);
        }
        break;
      default:
        if (wc.tlcb != null) wc.tlcb.callback(link);
        if (wc.tcb != null) wc.tcb.callback(link.linkId,link.linkStatus);
        wc.canNotify = true;
        break;
    }
    if (cc != 0)
    {
      link.linkStatus = cc;
      link.linkStatusSource = TLink.STATUS_LOCAL;
      if (wc.tlcb != null) wc.tlcb.callback(link);
      if (wc.tcb != null) wc.tcb.callback(link.linkId,cc);
      link.close();
      wc.canNotify = true;
    }
    return;
  }
}
