package de.desy.tine.console;

import java.lang.reflect.Method;

import de.desy.tine.definitions.TAccess;

public class TCommandItem
{
  private String cmdString = null;
  private String cmdDesc = null;
  public String getCommandString() { return cmdString; }
  public String getCommandDescription() { return cmdDesc; }
  private Method cmd = null;
  private int access = TAccess.CA_NULL;
  public boolean canSet() { return TAccess.isWrite((byte)access); }
  public boolean canGet() { return TAccess.isRead((byte)access); }
  public TCommandItem(String command,String description,Method method)
  {
    cmdString = command;
    cmdDesc = description;
    cmd = method;
    access = TAccess.CA_READ;
  }
  public TCommandItem(String command,String description,Method method,int access)
  {
    cmdString = command;
    cmdDesc = description;
    cmd = method;
    this.access = access;
  }
  public void invoke()
  {
    try
    {
      cmd.invoke((Object)null, (Object[])null);
    }
    catch (Exception e)
    {
      System.out.println("cannot invoke "+cmdString+" : "+e.getMessage());
    }
  }
  public void invoke(int value)
  {
    try
    {
      cmd.invoke((Object)null, new Integer(value));
    }
    catch (Exception e)
    {
      System.out.println("cannot invoke "+cmdString+" : "+e.getMessage());
    }
  }
  public void invoke(String value)
  {
    try
    {
      cmd.invoke((Object)null, value);
    }
    catch (Exception e)
    {
      System.out.println("cannot invoke "+cmdString+" : "+e.getMessage());
    }
  }
}
