/*
 * Created on Nov 10, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package de.desy.tine.io;
//import java.io.*;
import java.net.*;

import de.desy.tine.definitions.TErrorList;
import de.desy.tine.server.logger.MsgLog;
import de.desy.tine.server.logger.TFecLog;
import de.desy.tine.startup.TInitializer;
import de.desy.tine.startup.TInitializerFactory;

/**
 * \internal
 * TODO: This now appears to work -> just use a single MulticastSocket called 's'
 * 
 * @author duval
 *
 */
public class TPacket
{
  private static final int defaultRcvBufSiz = 0x10000;
  private static final int defaultTtl = 16;
  public static final int MAX_DATAGRAM_SIZE = 64000;
  private static final int MCAST_REATTACH_INTERVAL = 300000;
  private TInitializer initializer=TInitializerFactory.getInstance().getInitializer();
  private MulticastSocket sck;
  private int port = 0;
  public int getPort() { return port; }
  public MulticastSocket getSocket() { return sck; }
  public boolean canAttachToServiceGroup = false;
  private static long lastjoin = 0;
  private String os = null;
  public boolean isServiceGroupStale()
  {
    return isServiceGroupStale(System.currentTimeMillis());
  }
  public boolean isServiceGroupStale(long now)
  {
    if (now < lastjoin + MCAST_REATTACH_INTERVAL) return false;
    return true;
  }
  public void reAttachToServiceGroup()
  { // some routers will drop the member if there's no activity for a long time
    if (!canAttachToServiceGroup) return;
    try
    {
      InetAddress grp = InetAddress.getByName(initializer.getNetCastAddress());
      sck.joinGroup(grp);
    }
    catch (Exception e)
    {
      MsgLog.log("reAttachToServiceGroup", "could not reattach to group "+e.getMessage(),TErrorList.io_error,e,1);      
    }
    lastjoin = System.currentTimeMillis();
  }
  public void shutdown()
  {
    if (sck == null) return;
    try
    {
      sck.close();
    }
    catch (Exception e)
    {
      e.printStackTrace();
      System.err.println("could not close socket on port "+sck.getLocalPort());
    }
  }
  InetAddress hostAddress;
  private boolean isMCastListener = false;
  public boolean isMulticastListener() { return isMCastListener; }
  public DatagramPacket dpOut;
  byte[] bufIn = new byte[MAX_DATAGRAM_SIZE];
  public DatagramPacket dpIn = new DatagramPacket(bufIn, bufIn.length);
  public TPacket()
  {
    this(defaultRcvBufSiz,defaultTtl);
  }
  public TPacket(int rcvBufferSize, int timeToLive)
  {
    this(0,rcvBufferSize,timeToLive);
  }
  public TPacket(int port)
  {
    this(port,defaultRcvBufSiz,defaultTtl);
  }
  public TPacket(int port,int rcvBufferSize,int timeToLive)
  {
    int clnport = initializer.getClnPort();
    boolean useNextPort = (port == 0) ? true : false;
    boolean socketBound = false;
    InetAddress grp;
    String ip = TInitializerFactory.getInstance().getInitializer().getMyIpAddr();
    InetAddress iaddr = null;
    if (os == null) os = System.getProperty("os.name");
    for (int i=0; !socketBound && i<1000; i++)
    {
      try
      {
        if (port == 0) 
        { // general client side port
          //InetAddress iaddr = InetAddress.getLocalHost();
          iaddr = InetAddress.getByName(ip);
          if (os != null && os.contains("Linux")) iaddr = null;
          if (os != null && os.contains("Windows")) iaddr = null;
          InetSocketAddress addr = new InetSocketAddress(iaddr,clnport+i);
          sck = new MulticastSocket(null);
          sck.setReuseAddress(false);
          sck.bind(addr);
          sck.setSoTimeout(0);
          sck.setReceiveBufferSize(rcvBufferSize);
          sck.setTimeToLive(timeToLive);
          socketBound = true;
          this.port = clnport + i;
        } 
        else if (port == initializer.getGCastPort()) 
        { // globals listening port
          grp = InetAddress.getByName(initializer.getGCastAddress());
          sck = new MulticastSocket(port);
          sck.joinGroup(grp); // this is the canonical globals multicast group
          sck.setSoTimeout(0);
          sck.setTimeToLive(timeToLive);
          socketBound = true;
          isMCastListener = true;
          this.port = port;
        } 
        else if (port == initializer.getMCastPort()) 
        { // general multi-cast listening port
          grp = InetAddress.getByName(initializer.getMCastAddress());
          sck = new MulticastSocket(port);
          sck.joinGroup(grp); // this is the canonical server multicast group
          sck.setSoTimeout(0);
          sck.setReceiveBufferSize(rcvBufferSize);
          sck.setTimeToLive(timeToLive);
          socketBound = true;
          isMCastListener = true;
          this.port = port;
        } 
        else if (port == initializer.getNetCastPort()) 
        { // server port for responding to services request
          grp = InetAddress.getByName(initializer.getNetCastAddress());
          sck = new MulticastSocket(port);
          sck.joinGroup(grp);
          sck.setSoTimeout(0);
          sck.setReceiveBufferSize(rcvBufferSize);
          socketBound = true;
          isMCastListener = true;
          this.port = port;
          lastjoin = System.currentTimeMillis();
          canAttachToServiceGroup = true;
        } 
        else 
        { // server's listening port
//          InetSocketAddress addr = new InetSocketAddress(port);
//          //InetSocketAddress addr = new InetSocketAddress(InetAddress.getLocalHost(),port);
          //String ip = TInitializerFactory.getInstance().getInitializer().getMyIpAddr();
          //InetAddress iaddr = InetAddress.getByName(ip);
          iaddr = InetAddress.getByName(ip);
          if (os != null && os.contains("Linux")) iaddr = null;
          if (os != null && os.contains("Windows")) iaddr = null;
          InetSocketAddress addr = new InetSocketAddress(iaddr,port);
          sck = new MulticastSocket(null);
          sck.setReuseAddress(false);
          sck.bind(addr);          
          sck.setSoTimeout(0);
          sck.setReceiveBufferSize(rcvBufferSize);
          sck.setTimeToLive(timeToLive);
          socketBound = true;
          this.port = port;
        }
      }
      catch (Exception e)
      {
        if (!useNextPort)
        {
          System.err.println("Can't open socket");
          e.printStackTrace();
          MsgLog.log("TPacket",e.toString(),TErrorList.udp_socket_error,e,0);
          TFecLog.log("Cannot initialize socket: "+e.toString());
          break;
        }
      }
    }
  }
}
