/*
 * Created on Feb 16, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.desy.tine.stringUtils;

/**
 * \internal
 * 
 * @author jwlg TODO To change the template for this generated type comment go
 *         to Window - Preferences - Java - Code Style - Code Templates
 */
public class WildcardMatch
{
  private String[] parts; // Things we don't show around in public.
  private boolean startFixed = true;
  private boolean endFixed = true;
  private boolean matchAll;
  private boolean matchSingle;
  private boolean valid = true;
  private boolean caseSensitive = false;
  public WildcardMatch(String pattern)
  {
    valid = ((pattern != null) && (pattern.length() > 0));
    if (valid)
    {
      matchAll = pattern.equals("*");
      matchSingle = pattern.indexOf("*") < 0;
      if (matchAll)
      {
        parts = null;
      }
      else if (matchSingle)
      {
        parts = new String[1];
        parts[0] = pattern;
      }
      else
      {
        startFixed = !pattern.startsWith("*");
        endFixed = !pattern.endsWith("*");
        parts = pattern.split("\\*");
        valid = (parts != null);
      }
    }
  }
  public boolean matches(String comparedText)
  {
    boolean rv = valid; // if valid, set rv true optimistically
    int foundIndex; // where a substring was found;
    int startIndex; // eherethe next substring search starts;
    int restLength;
    String portion = null;
    String text = comparedText;
    if (this.caseSensitive)
    {
      text = text.toLowerCase();
    }
    restLength = text.length();
    if (!valid)
    {
      rv = false;
    }
    else if (matchAll)
    {
      rv = true;
    }
    else if (matchSingle)
    {
      rv = text.equals(parts[0]);
    }
    else
    {
      // Preliminary condition
      if (startFixed)
      {
        rv = rv && text.startsWith(parts[0]);
      }
      // partial match
      startIndex = 0;
      for (int i = 0; ((i < parts.length) && rv); i++)
      {
        if (parts[i].length() > 0)
        { // tolerate multiple "**" (not necessary)
          portion = parts[i];
          if (this.caseSensitive) portion = portion.toLowerCase();
          foundIndex = text.indexOf(portion, startIndex);
          if (foundIndex >= 0)
          {
            startIndex = foundIndex + portion.length();
            restLength = text.length() - startIndex;
            rv = (restLength >= 0);
          }
          else
          { // not found
            rv = false; // breaks loop
          }
        }
      }
      if (rv && endFixed)
      { // rest length must be 0 if end fizxed
        rv = (restLength == 0);
      }
    }
    return rv;
  }
  /**
   * @return Returns true if the case sensitivity is set.
   */
  public boolean isCaseSensitive()
  {
    return caseSensitive;
  }
  /**
   * @param value
   *          Case sensitiviety to set .
   */
  public void setCaseSensitive(boolean value)
  {
    this.caseSensitive = value;
  }
}
